/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/array.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "array.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/array.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: array.pmc 40100 2009-07-15 13:15:25Z bacek $

=head1 NAME

src/pmc/array.pmc - Array PMC

=head1 DESCRIPTION

These are the vtable functions for the Array base class.

=head2 Functions

=over 4

=cut

*/

/*

=item C<static PMC *undef(PARROT_INTERP)>

Returns a C<Undef> PMC.

=cut

*/

static PMC *undef(PARROT_INTERP) {
    return pmc_new(interp, enum_class_Undef);
}

/*

=item C<static PMC *retval(PARROT_INTERP, void *ret)>

Processes C<*ret>, returning the appropriate PMC, or raising an
exception if necessary.

=cut

*/

static PMC *retval(PARROT_INTERP, void *ret) {
    PMC *value;

    if (ret == NULL)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    /* XXX getting non existent value, exception or undef?
     * current is for perlarray */
    if (ret == (void *)-1)
        value = undef(interp);
    else {
        value = *(PMC **)ret;

        /* XXX same here */
        if (!value)
            value = undef(interp);
    }

    return value;
}

/*

=item C<static PMC
*Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key)>

Returns a pointer to the element at index C<key> of C<*list>. If
this element was previously empty, then this function also creates
and assigns an "undef" PMC to that element.

=cut

*/

static PMC *Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key) {
    void * const ret = list_get(interp, list, key, enum_type_PMC);
    PMC  *value;

    if (ret == NULL)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    /* assign into a sparse or not yet set value */
    if (ret == (void *)-1 || *(PMC **)ret == NULL) {
        value = undef(interp);
        list_assign(interp, list, key, value, enum_type_PMC);
    }
    else
        value = *(PMC **)ret;

    return value;
}
#line 121 "./src/pmc/array.c"
static  void  Parrot_Array_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *other);
static  PMC  * Parrot_Array_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Array_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_Array_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_Array_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_Array_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Array_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_Array_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_Array_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Array_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_Array_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Array_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Array_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_Array_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_Array_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_Array_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING  * Parrot_Array_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Array_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Array_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void  Parrot_Array_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Array_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init);
static  INTVAL  Parrot_Array_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Array_mark(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Array_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Array_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Array_pop_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Array_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Array_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Array_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Array_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_Array_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_Array_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_Array_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size);
static  void  Parrot_Array_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Array_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_Array_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void  Parrot_Array_set_pmc(PARROT_INTERP, PMC *pmc, PMC *other);
static  void  Parrot_Array_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_Array_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *src);
static  void  Parrot_Array_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_Array_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value);
static  PMC  * Parrot_Array_share_ro(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Array_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Array_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Array_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Array_shift_string(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_Array_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f);
static  void  Parrot_Array_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count);
static  void  Parrot_Array_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_Array_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Array_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Array_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Array_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_Array_visit(PARROT_INTERP, PMC *pmc, visit_info *info);
void    Parrot_Array_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Array_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Array_get_vtable(PARROT_INTERP);
void    Parrot_Array_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Array_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Array_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_Array_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 164 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, other);
    INTVAL       i;

    VTABLE_set_integer_native(interp, pmc, size);
    for (i = 0; i < size; i++) {
        PMC * const elem = VTABLE_get_pmc_keyed_int(interp, other, i);
        VTABLE_set_pmc_keyed_int(interp, pmc, i, elem);
    }
#line 200 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_clone(PARROT_INTERP, PMC *pmc)
{
#line 214 "./src/pmc/array.pmc"

    List       *l    = list_clone(interp, (List *)PMC_data(pmc));
    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);

    PObj_custom_mark_SET(dest);

    PMC_data(dest) = l;
    l->container   = dest;

    return dest;
#line 216 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1030 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = VTABLE_get_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_defined_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_defined_keyed(interp, box, nextkey);
#line 237 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1004 "./src/pmc/array.pmc"

    PMC  *value;
    void * const ret =
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == NULL || ret == (void *) -1)
        return 0;

    value = *(PMC **)ret;

    if (!value)
        return 0;

    return VTABLE_defined(interp, value);
#line 257 "./src/pmc/array.c"
}
static  void 
Parrot_Array_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1118 "./src/pmc/array.pmc"

    const INTVAL ix = VTABLE_get_integer(interp, key);
    list_splice(interp, (List *)PMC_data(pmc), NULL, ix, 1);
#line 266 "./src/pmc/array.c"
}
static  void 
Parrot_Array_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1104 "./src/pmc/array.pmc"

    list_splice(interp, (List *)PMC_data(pmc), NULL, key, 1);
#line 274 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_elements(PARROT_INTERP, PMC *pmc)
{
#line 265 "./src/pmc/array.pmc"

    return ((const List *) PMC_data(pmc))->length;
#line 282 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1077 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = VTABLE_get_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_exists_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_exists_keyed(interp, box, nextkey);
#line 303 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1057 "./src/pmc/array.pmc"

    void * ret = list_get(interp,
        (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == NULL || ret == (void *)-1)
        return 0;

    return !PMC_IS_NULL(*(PMC **)ret);
#line 317 "./src/pmc/array.c"
}
static  void 
Parrot_Array_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1217 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;
    interp->vtables[enum_class_default]->freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
#line 327 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 250 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 336 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 236 "./src/pmc/array.pmc"

    return VTABLE_elements(interp, pmc);
#line 344 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 324 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_integer_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_integer_keyed(interp, box, nextkey);
#line 369 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 308 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_integer(interp, value);
#line 379 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 1186 "./src/pmc/array.pmc"

    return pmc_new_init(interp, enum_class_ArrayIterator, pmc);
#line 387 "./src/pmc/array.c"
}
static  FLOATVAL 
Parrot_Array_get_number(PARROT_INTERP, PMC *pmc)
{
#line 279 "./src/pmc/array.pmc"

    const INTVAL e = VTABLE_elements(interp, pmc);
    return (FLOATVAL)e;
#line 396 "./src/pmc/array.c"
}
static  FLOATVAL 
Parrot_Array_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 372 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC *nextkey, *box;

    if (!key)
        return (FLOATVAL)0;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_number_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_number_keyed(interp, box, nextkey);
#line 421 "./src/pmc/array.c"
}
static  FLOATVAL 
Parrot_Array_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 355 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_number(interp, value);

#line 432 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 466 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return NULL;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_pmc_keyed(interp, box, nextkey);
#line 457 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 450 "./src/pmc/array.pmc"


    return retval(interp,
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC));
#line 467 "./src/pmc/array.c"
}
static  STRING  *
Parrot_Array_get_string(PARROT_INTERP, PMC *pmc)
{
#line 294 "./src/pmc/array.pmc"

    return Parrot_sprintf_c(interp, "array[%p]", pmc);
#line 475 "./src/pmc/array.c"
}
static  STRING  *
Parrot_Array_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 419 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return NULL;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_string_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_string_keyed(interp, box, nextkey);
#line 500 "./src/pmc/array.c"
}
static  STRING  *
Parrot_Array_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 403 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_string(interp, value);
#line 510 "./src/pmc/array.c"
}
static  void 
Parrot_Array_init(PARROT_INTERP, PMC *pmc)
{
#line 133 "./src/pmc/array.pmc"

    list_pmc_new(interp, pmc);
    PObj_custom_mark_SET(pmc);
#line 519 "./src/pmc/array.c"
}
static  void 
Parrot_Array_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 149 "./src/pmc/array.pmc"

    list_pmc_new_init(interp, pmc, init);
    PObj_custom_mark_SET(pmc);
#line 528 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1133 "./src/pmc/array.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_Array)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC * const item1 = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        PMC * const item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 != item2) {
            const INTVAL result = VTABLE_is_equal(interp, item1, item2);
            if (!result)
                return 0;
        }
    }

    return 1;
#line 557 "./src/pmc/array.c"
}
static  void 
Parrot_Array_mark(PARROT_INTERP, PMC *pmc)
{
#line 200 "./src/pmc/array.pmc"

    list_mark(interp, (List *)PMC_data(pmc));
#line 565 "./src/pmc/array.c"
}
static  FLOATVAL 
Parrot_Array_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 876 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 574 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 861 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 583 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 906 "./src/pmc/array.pmc"

    return retval(interp,
        list_pop(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 592 "./src/pmc/array.c"
}
static  STRING  *
Parrot_Array_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 891 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 601 "./src/pmc/array.c"
}
static  void 
Parrot_Array_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 746 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, nextix, value);
#line 610 "./src/pmc/array.c"
}
static  void 
Parrot_Array_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 730 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 619 "./src/pmc/array.c"
}
static  void 
Parrot_Array_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 778 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, nextix, value);
#line 628 "./src/pmc/array.c"
}
static  void 
Parrot_Array_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 762 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, nextix, value);
#line 637 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 542 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_integer_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 665 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 525 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_integer_native(interp, ptr, value);
#line 676 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 497 "./src/pmc/array.pmc"

    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 684 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 510 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, value);
    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 693 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 593 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_number_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 721 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 576 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_number_native(interp, ptr, value);
#line 732 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 186 "./src/pmc/array.pmc"

    VTABLE_assign_pmc(interp, pmc, other);
#line 740 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 699 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = VTABLE_get_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_pmc_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 764 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *src)
{
#line 678 "./src/pmc/array.pmc"

    const INTVAL length = ((List *)PMC_data(pmc))->length;

    if (idx >= length || -idx > length)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    list_assign(interp, (List *)PMC_data(pmc), idx,
        (void *)src, enum_type_PMC);
#line 779 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 644 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = VTABLE_get_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_string_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 807 "./src/pmc/array.c"
}
static  void 
Parrot_Array_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 627 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_string_native(interp, ptr, value);
#line 818 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1251 "./src/pmc/array.pmc"

    PMC *_true, *ret;

    /* prevent infinite recursion */
    if (PObj_is_PMC_shared_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "share_ro on something that already is shared");

    _true = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, _true, 1);

    ret   = pt_shared_fixup(interp, pmc);

    /* first set readonly */
    VTABLE_setprop(interp, ret, CONST_STRING(interp, "_ro"), _true);

    /* XXX do something that deals better with sparse lists */
    {
        INTVAL i;
        const INTVAL max = VTABLE_elements(interp, ret);

        for (i = 0; i < max; ++i) {
            PMC * const value =
                (PMC *)list_get(interp, PMC_data_typed(ret, List *),
                             i, enum_type_PMC);

            if (!PMC_IS_NULL(value)) {
                /* XXX do we need to clone first? */
                PMC * const new_value = VTABLE_share_ro(interp, value);

                if (new_value != value)
                    list_assign(interp, PMC_data_typed(ret, List *),
                        i, new_value, enum_type_PMC);
            }
        }
    }

    /* XXX FIXME workaround lack of metadata sharing */
    PMC_metadata(pmc) = NULL;

    return ret;
#line 865 "./src/pmc/array.c"
}
static  FLOATVAL 
Parrot_Array_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 936 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 874 "./src/pmc/array.c"
}
static  INTVAL 
Parrot_Array_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 921 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 883 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 966 "./src/pmc/array.pmc"

    return retval(interp,
        list_shift(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 892 "./src/pmc/array.c"
}
static  STRING  *
Parrot_Array_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 951 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 901 "./src/pmc/array.c"
}
static  PMC  *
Parrot_Array_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1174 "./src/pmc/array.pmc"

    if (f == 0) {
        STRING * const name = CONST_STRING(interp, "set_key");
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        Parrot_PCCINVOKE(interp, iter, name, "P->", key);
        return iter;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Array: Unknown slice type");
#line 917 "./src/pmc/array.c"
}
static  void 
Parrot_Array_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 985 "./src/pmc/array.pmc"

    if (pmc->vtable->base_type != value->vtable->base_type)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Type mismatch in splice");

    list_splice(interp, (List *)PMC_data(pmc),
        (List *)PMC_data(value), offset, count);
#line 930 "./src/pmc/array.c"
}
static  void 
Parrot_Array_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1233 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;

    interp->vtables[enum_class_default]->thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
}
#line 943 "./src/pmc/array.c"
}
static  void 
Parrot_Array_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 812 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_number_native(interp, val, value);
#line 954 "./src/pmc/array.c"
}
static  void 
Parrot_Array_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 794 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_integer_native(interp, val, value);
#line 965 "./src/pmc/array.c"
}
static  void 
Parrot_Array_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 847 "./src/pmc/array.pmc"

    list_unshift(interp, (List *)PMC_data(pmc), value, enum_type_PMC);
#line 973 "./src/pmc/array.c"
}
static  void 
Parrot_Array_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 830 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);
    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_string_native(interp, val, value);
#line 983 "./src/pmc/array.c"
}
static  void 
Parrot_Array_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1202 "./src/pmc/array.pmc"

    list_visit(interp, (List *)PMC_data(pmc), info);
    interp->vtables[enum_class_default]->visit(interp, pmc, info);
#line 992 "./src/pmc/array.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Array_update_vtable(VTABLE *vt) {
    vt->assign_pmc = Parrot_Array_assign_pmc;
    vt->clone = Parrot_Array_clone;
    vt->defined_keyed = Parrot_Array_defined_keyed;
    vt->defined_keyed_int = Parrot_Array_defined_keyed_int;
    vt->delete_keyed = Parrot_Array_delete_keyed;
    vt->delete_keyed_int = Parrot_Array_delete_keyed_int;
    vt->elements = Parrot_Array_elements;
    vt->exists_keyed = Parrot_Array_exists_keyed;
    vt->exists_keyed_int = Parrot_Array_exists_keyed_int;
    vt->freeze = Parrot_Array_freeze;
    vt->get_bool = Parrot_Array_get_bool;
    vt->get_integer = Parrot_Array_get_integer;
    vt->get_integer_keyed = Parrot_Array_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Array_get_integer_keyed_int;
    vt->get_iter = Parrot_Array_get_iter;
    vt->get_number = Parrot_Array_get_number;
    vt->get_number_keyed = Parrot_Array_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Array_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_Array_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Array_get_pmc_keyed_int;
    vt->get_string = Parrot_Array_get_string;
    vt->get_string_keyed = Parrot_Array_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Array_get_string_keyed_int;
    vt->init = Parrot_Array_init;
    vt->init_pmc = Parrot_Array_init_pmc;
    vt->is_equal = Parrot_Array_is_equal;
    vt->mark = Parrot_Array_mark;
    vt->pop_float = Parrot_Array_pop_float;
    vt->pop_integer = Parrot_Array_pop_integer;
    vt->pop_pmc = Parrot_Array_pop_pmc;
    vt->pop_string = Parrot_Array_pop_string;
    vt->push_float = Parrot_Array_push_float;
    vt->push_integer = Parrot_Array_push_integer;
    vt->push_pmc = Parrot_Array_push_pmc;
    vt->push_string = Parrot_Array_push_string;
    vt->set_integer_keyed = Parrot_Array_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_Array_set_integer_keyed_int;
    vt->set_integer_native = Parrot_Array_set_integer_native;
    vt->set_integer_same = Parrot_Array_set_integer_same;
    vt->set_number_keyed = Parrot_Array_set_number_keyed;
    vt->set_number_keyed_int = Parrot_Array_set_number_keyed_int;
    vt->set_pmc = Parrot_Array_set_pmc;
    vt->set_pmc_keyed = Parrot_Array_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_Array_set_pmc_keyed_int;
    vt->set_string_keyed = Parrot_Array_set_string_keyed;
    vt->set_string_keyed_int = Parrot_Array_set_string_keyed_int;
    vt->share_ro = Parrot_Array_share_ro;
    vt->shift_float = Parrot_Array_shift_float;
    vt->shift_integer = Parrot_Array_shift_integer;
    vt->shift_pmc = Parrot_Array_shift_pmc;
    vt->shift_string = Parrot_Array_shift_string;
    vt->slice = Parrot_Array_slice;
    vt->splice = Parrot_Array_splice;
    vt->thaw = Parrot_Array_thaw;
    vt->unshift_float = Parrot_Array_unshift_float;
    vt->unshift_integer = Parrot_Array_unshift_integer;
    vt->unshift_pmc = Parrot_Array_unshift_pmc;
    vt->unshift_string = Parrot_Array_unshift_string;
    vt->visit = Parrot_Array_visit;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Array_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Array_clone;
    vt->defined_keyed = Parrot_Array_defined_keyed;
    vt->defined_keyed_int = Parrot_Array_defined_keyed_int;
    vt->elements = Parrot_Array_elements;
    vt->exists_keyed = Parrot_Array_exists_keyed;
    vt->exists_keyed_int = Parrot_Array_exists_keyed_int;
    vt->freeze = Parrot_Array_freeze;
    vt->get_bool = Parrot_Array_get_bool;
    vt->get_integer = Parrot_Array_get_integer;
    vt->get_integer_keyed = Parrot_Array_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Array_get_integer_keyed_int;
    vt->get_iter = Parrot_Array_get_iter;
    vt->get_number = Parrot_Array_get_number;
    vt->get_number_keyed = Parrot_Array_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Array_get_number_keyed_int;
    vt->get_pmc_keyed = Parrot_Array_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Array_get_pmc_keyed_int;
    vt->get_string = Parrot_Array_get_string;
    vt->get_string_keyed = Parrot_Array_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Array_get_string_keyed_int;
    vt->init = Parrot_Array_init;
    vt->init_pmc = Parrot_Array_init_pmc;
    vt->is_equal = Parrot_Array_is_equal;
    vt->mark = Parrot_Array_mark;
    vt->share_ro = Parrot_Array_share_ro;
    vt->slice = Parrot_Array_slice;
    vt->visit = Parrot_Array_visit;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Array_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Array_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Array_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Array_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Array_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Array", 5, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Array_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Array")), PMCNULL);
    return isa;
}

void
Parrot_Array_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Array_get_vtable(interp);
        vt->base_type      = enum_class_Array;
        vt->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Array");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Array_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Array;
            vt_ro->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Array_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
        {
        
        

        }
        {
        }
    } /* pass */
} /* Parrot_Array_class_init */
#line 1292 "./src/pmc/array.pmc"


/*

=back

=head1 SEE ALSO

F<src/list.c>, F<include/parrot/list.h>

=head1 TODO

Create global immutable undef object.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
