/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/continuation.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: continuation.pmc 39234 2009-05-29 09:52:20Z chromatic $

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location where
the Continuation was constructed.  See the L<Glossary|docs/glossary.pod> for
more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/oplib/ops.h"
#include "pmc_sub.h"

/*

=back

=head2 Methods

=over 4

=cut

*/


/*
 * A Continuation (and RetContinuation, ExceptionHandler) has in its
 * context a pointer to the register frame, which contains active objects.
 * Additionally ct->current_cont has the continuation of the caller.
 * To avoid deep recursion during marking of nested subroutines, we
 * need the next_for_GC pointer in the pmc_ext area.
 */
#line 69 "./src/pmc/continuation.c"
static  PMC  * Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc);
static  void  * Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_init(PARROT_INTERP, PMC *pmc);
static  opcode_t  * Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src);
static  void  Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc);
static  void Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc);
void    Parrot_Continuation_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP);
void    Parrot_Continuation_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc)
{
#line 136 "./src/pmc/continuation.pmc"

    Parrot_cont * const cc_self  = PMC_cont(pmc);
    Parrot_cont * const cc       = new_continuation(interp, cc_self);
    PMC         * const ret      = pmc_new(interp, enum_class_Continuation);
    Parrot_cont * const ret_cont = PMC_cont(ret);

    PObj_custom_mark_destroy_SETALL(ret);

    /* free ret's PMC_cont */
    Parrot_free_context(interp, ret_cont->from_ctx, 1);
    mem_sys_free(ret_cont);

    cc->runloop_id = cc_self->runloop_id;
    PMC_cont(ret)  = cc;

    return ret;
#line 109 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc)
{
#line 218 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address != NULL;
#line 117 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_destroy(PARROT_INTERP, PMC *pmc)
{
#line 107 "./src/pmc/continuation.pmc"

    Parrot_cont * const cc = PMC_cont(pmc);
    if (cc) {
#if CTX_LEAK_DEBUG
        if (Interp_debug_TEST(interp, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
            fprintf(stderr,
                    "[destroy cont    %p, to_ctx %p, from_ctx %p]\n",
                    (void *)pmc, (void *)cc->to_ctx, (void *)cc->from_ctx);
        }

#endif
        if (cc->from_ctx)
            Parrot_free_context(interp, cc->from_ctx, 1);

        mem_sys_free(cc);
    }
    mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
#line 141 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 222 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address != NULL;
#line 149 "./src/pmc/continuation.c"
}
static  void  *
Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 203 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address;
#line 157 "./src/pmc/continuation.c"
}
static  STRING  *
Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc)
{
#line 288 "./src/pmc/continuation.pmc"

    return Parrot_Context_infostr(interp, PMC_cont(pmc)->to_ctx);
#line 165 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init(PARROT_INTERP, PMC *pmc)
{
#line 61 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Continuation_attributes);
    PMC_data(pmc) = attrs;

    PMC_cont(pmc) = new_continuation(interp, NULL);
    PObj_custom_mark_destroy_SETALL(pmc);
    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain may be reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 186 "./src/pmc/continuation.c"
}
static  opcode_t  *
Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 237 "./src/pmc/continuation.pmc"

    Parrot_cont      *cc           = PMC_cont(pmc);
    Parrot_Context   *from_ctx     = CONTEXT(interp);
    Parrot_Context   *to_ctx       = cc->to_ctx;
    opcode_t         *pc           = cc->address;
    UNUSED(next)

    Parrot_continuation_check(interp, pmc, cc);
    Parrot_continuation_rewind_environment(interp, pmc, cc);

    /* pass args to where caller wants result */
    if (cc->current_results)
        to_ctx->current_results = cc->current_results;

    if (to_ctx->current_results && interp->current_args) {
        /*
         * the register pointer is already switched back
         * to the caller, therefore the registers of the
         * sub we are returning from aren't marked, if
         * inside argument passing a GC run is triggered
         * therefore we have to block GC
         */
        opcode_t *src_indexes  = interp->current_args;
        opcode_t *dest_indexes = to_ctx->current_results;
        interp->current_args   = NULL;

        Parrot_block_GC_mark(interp);
        parrot_pass_args(interp, from_ctx, to_ctx,
                         src_indexes, dest_indexes, PARROT_PASS_PARAMS);
        Parrot_unblock_GC_mark(interp);
    }

    /* switch segment */
    interp->current_args = NULL;

    if (interp->code != cc->seg)
        Parrot_switch_to_cs(interp, cc->seg, 1);

    return pc;
#line 231 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc)
{
#line 88 "./src/pmc/continuation.pmc"

    Parrot_cont *cc = PMC_cont(pmc);

    if (cc->to_ctx)
        mark_context(interp, cc->to_ctx);
    if (cc->from_ctx)
        mark_context(interp, cc->from_ctx);
#line 244 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src)
{
#line 163 "./src/pmc/continuation.pmc"

    Parrot_cont * const cc_self = PMC_cont(pmc);
    Parrot_cont * const cc_src  = PMC_cont(src);

    STRUCT_COPY(cc_self, cc_src);
#line 255 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 180 "./src/pmc/continuation.pmc"

    opcode_t    * const pos = (opcode_t *)value;
    Parrot_cont * const cc  = PMC_cont(pmc);

    cc->address       = (opcode_t *)value;
    cc->runloop_id    = interp->current_runloop_id;

    if (pos && (*pos == PARROT_OP_get_results_pc))
        cc->current_results = pos;
    else
        cc->current_results = NULL;
#line 272 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 310 "./src/pmc/continuation.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 327 "./src/pmc/continuation.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 302 "./src/pmc/continuation.pmc"

    Parrot_cont *cc     = PMC_cont(pmc);
    PMC         *caller = cc->to_ctx->current_sub;
    Parrot_sub  *sub;

    PMC_get_sub(interp, caller, sub);
    if (!caller || !sub->seg)
        caller = PMCNULL;

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *caller */
    /*BEGIN GENERATED ACCESSORS */
#line 348 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = caller;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto caller_returns;
    /*END RETURN PMC *caller */
    }
#line 311 "./src/pmc/continuation.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
caller_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 394 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 432 "./src/pmc/continuation.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 449 "./src/pmc/continuation.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 324 "./src/pmc/continuation.pmc"

    Parrot_cont *cc   = PMC_cont(pmc);
    PMC         *cont = cc->to_ctx->current_cont;

    if (cont)
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *cont */
    /*BEGIN GENERATED ACCESSORS */
#line 466 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = cont;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto continuation_returns;
    /*END RETURN PMC *cont */
    }
#line 329 "./src/pmc/continuation.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 490 "./src/pmc/continuation.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto continuation_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 331 "./src/pmc/continuation.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
continuation_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 535 "./src/pmc/continuation.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Continuation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->destroy = Parrot_Continuation_destroy;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->set_pmc = Parrot_Continuation_set_pmc;
    vt->set_pointer = Parrot_Continuation_set_pointer;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->destroy = Parrot_Continuation_destroy;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Continuation_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Continuation_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Continuation_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Continuation", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Continuation_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Continuation")), PMCNULL);
    return isa;
}

void
Parrot_Continuation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":cont ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Continuation_get_vtable(interp);
        vt->base_type      = enum_class_Continuation;
        vt->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Continuation");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Continuation_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Continuation;
            vt_ro->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Continuation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_caller), CONST_STRING_GEN(interp, "caller"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_continuation), CONST_STRING_GEN(interp, "continuation"));
        {
        }
    } /* pass */
} /* Parrot_Continuation_class_init */
#line 332 "./src/pmc/continuation.pmc"


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
