/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "pmc_default.h"
#include "default.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/default.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: default.pmc 39963 2009-07-09 17:25:32Z chromatic $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<src/vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#define INT2KEY(i, k) key_new_integer((i), (k))

/* undef 'interface' to keep MSVC happy */
#undef interface

/*

=item C<static STRING *caller(PARROT_INTERP, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static STRING *
caller(PARROT_INTERP, PMC *pmc /*NULLOK*/)
{
    STRING * const null_str = CONST_STRING(interp, "(null)");

    return pmc && pmc->vtable && pmc->vtable->whoami
                ? VTABLE_name(interp, pmc) : null_str;
}

/*

=item C<static void cant_do_method(PARROT_INTERP, PMC *pmc,
                                   const char *methname)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
cant_do_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, const char *methname)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "%s() not implemented in class '%Ss'", methname,
            caller(interp, pmc));
}


/*

=item C<static void cant_do_write_method(PARROT_INTERP, PMC *pmc,
                                   const char *methname)>

Throws an exception "$methname() on read-only instance of '$class'", used by
all updating messages on read-only instances.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
cant_do_write_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, const char *methname)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "%s() in read-only instance of '%Ss'", methname,
            caller(interp, pmc));
}

/*

=item C<static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

Returns a true value if C<setprop()> can avoid actually setting a property
in the prophash. If it returns true, the property setting will be reflected
in a future call to C<propagate_std_props()>

=cut

*/

static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    /* the quick hack below cannot be used because the string could
       be constructed in an interpreter that is later destroyed */
#if  0
    /* RT #46659
     * a quick hack, to prevent freeing that string during GC
     * triggered in t/pmc/pmc_62.t when configured with --gc=libc
     */
    static STRING *ro;
    if (!ro)
        ro = string_make(interp, "_ro", 3, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
    if (Parrot_str_equal(interp, key, ro)) {
#else

    /*
     * s2 in Parrot_str_equal is freed here
     */
    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "_ro"))) {
#endif
        /* pmc should set/clear readonly */
        const INTVAL on = VTABLE_get_bool(interp, value);

        /* morph to Const/normal class or readonly class */
        /* RT #46661 warn when this fails? */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interp->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & (VTABLE_IS_CONST_FLAG)))
            VTABLE_morph(interp, pmc, interp->vtables[pmc->vtable->base_type - 1]->pmc_class);
        else if (on && (pmc->vtable->flags & VTABLE_HAS_READONLY_FLAG))
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else if (!on && (pmc->vtable->flags & VTABLE_IS_READONLY_FLAG)
                && pmc->vtable->ro_variant_vtable)
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else
            return 0;

        return 1;
    }

    return 0;
}

/*

=item C<static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash)>

Set pending standard properties in C<prop_hash>.

=cut

*/

static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG)){
        PMC * const pmc_true  = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, pmc_true, 1);
        VTABLE_set_pmc_keyed_str(interp, prop_hash, CONST_STRING(interp, "_ro"), pmc_true);
    }
}

/*

=item C<static INTVAL
has_pending_std_props(ARGIN(const PMC *self))>

Returns true if propagate_std_props() would create a non-empty prophash.

=cut

*/

static INTVAL
has_pending_std_props(ARGIN(const PMC *self)) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        return 1;
    else
        return 0;
}


/*

=item C<static PMC*
check_get_std_props(PARROT_INTERPeter, PMC *self, STRING *key)>

Checks if we can infer the value of C<key> property from C<self> without
looking at its prophash. Returns C<PMCNULL> if not, returns the value otherwise.

=cut
*/

static PMC*
check_get_std_props(PARROT_INTERP, PMC *self, STRING *key) {
    if ((self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
       && Parrot_str_equal(interp, key, CONST_STRING(interp, "_ro"))) {
        PMC * const ret_val  = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, ret_val, 1);
        return ret_val;
    }
    else
        return PMCNULL;
}

/*

=item C<static PMC *
make_prop_hash(PARROT_INTERP, PMC *self)>

Create a property hash for C<self>. Returns the created hash. Inferred
properties will be added to the hash and it will be set as
C<PMC_metadata(self)>.

=cut

*/

static PMC*
make_prop_hash(PARROT_INTERP, PMC *self) {
    PMC *prop;

    if (!self->pmc_ext)
        Parrot_gc_add_pmc_ext(interp, self);

    PMC_metadata(self) = prop = pmc_new(interp, enum_class_Hash);
    GC_WRITE_BARRIER(interp, self, NULL, prop);
    propagate_std_props(interp, self, prop);
    return prop;
}

/*

=item C<static INTVAL
does_isa(PARROT_INTERP, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.
Returns true (1) if B<method> is found in B<what>, false (0) otherwise.

=cut

*/

static INTVAL
does_isa(PARROT_INTERP, const STRING *method, const STRING *what)
{
    INTVAL  pos    = 0;
    INTVAL  length = Parrot_str_byte_length(interp, what);

    do {
        INTVAL len;
        INTVAL idx = Parrot_str_find_index(interp, what, method, (INTVAL)pos);

        if (idx < 0)
            return 0;

        pos = idx;

        if (pos >= length)
            return 0;

        len = Parrot_str_byte_length(interp, method);

        if (pos && Parrot_str_indexed(interp, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos + len < length && Parrot_str_indexed(interp, what, pos + len) != 32) {
            pos += len;
            continue;
        }

        return 1;
    } while (1);
}
#line 306 "./src/pmc/default.c"
static  PMC * Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type);
static  PMC  * Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc);
static  void  Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc);
static  void  Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  PMC  * Parrot_default_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_default_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_default_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_default_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_default_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_default_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_default_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_default_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC  * Parrot_default_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  INTVAL  Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method);
static  PMC*  Parrot_default_clone(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args);
static  INTVAL  Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_default_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest);
static  void Parrot_default_decrement(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_default_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  void Parrot_default_destroy(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  INTVAL  Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface);
static  INTVAL  Parrot_default_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role);
static  INTVAL Parrot_default_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  PMC  * Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  PMC  * Parrot_default_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name);
static  PMC * Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx);
static  PMC * Parrot_default_get_bignum(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_get_bool(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_get_class(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_default_get_iter(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_get_namespace(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC * Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC * Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  * Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc);
static  void * Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void * Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  void * Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  STRING * Parrot_default_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_get_string(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING * Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_default_getprops(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_i_bitwise_not(PARROT_INTERP, PMC *pmc);
static  void Parrot_default_i_bitwise_nots(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_i_neg(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_i_pow(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer);
static  PMC  * Parrot_default_inspect(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *name);
static  PMC  * Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *init);
static  PMC * Parrot_default_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags);
static  opcode_t * Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  INTVAL  Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class);
static  INTVAL  Parrot_default_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup);
static  PMC  * Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC  * Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_default_mark(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_morph(PARROT_INTERP, PMC *pmc, PMC *type);
static  PMC  * Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  STRING  * Parrot_default_name(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_default_nextkey_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL what);
static  PMC  * Parrot_default_nextkey_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL w);
static  PMC * Parrot_default_nextkey_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL what);
static  FLOATVAL Parrot_default_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_pop_string(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_default_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name);
static  void Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name);
static  void Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role);
static  void Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name);
static  PMC  * Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value);
static  void Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value);
static  void Parrot_default_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value);
static  void Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value);
static  void Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value);
static  void Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value);
static  void Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value);
static  void Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string);
static  void Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  void Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_default_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void Parrot_default_share(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_share_ro(PARROT_INTERP, PMC *pmc);
static  FLOATVAL Parrot_default_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING * Parrot_default_shift_string(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_default_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag);
static  void Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count);
static  void Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest);
static  STRING * Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length);
static  PMC  * Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_default_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_default_type(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_default_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_default_visit(PARROT_INTERP, PMC *pmc, visit_info *info);
void    Parrot_default_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_default_get_vtable(PARROT_INTERP);
static  PMC *
Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, "absolute");
}
static  PMC  *
Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1164 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add", "PPP->P", pmc, value, dest, &result);
    return result;
#line 567 "./src/pmc/default.c"
}
static  void
Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    UNUSED(name)
    UNUSED(type)
    cant_do_method(interp, pmc, "add_attribute");
}
static  PMC  *
Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1198 "./src/pmc/default.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 586 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1181 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 597 "./src/pmc/default.c"
}
static  void 
Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
#line 514 "./src/pmc/default.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc->vtable->_namespace,
                             method_name, sub_pmc);
#line 606 "./src/pmc/default.c"
}
static  void 
Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 1050 "./src/pmc/default.pmc"

    UNUSED(parent)
    if (!PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Only classes can be subclassed");

    Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "All classes should override add_parent");
#line 620 "./src/pmc/default.c"
}
static  void
Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_method(interp, pmc, "add_role");
}
static  void
Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    UNUSED(vtable_name)
    UNUSED(sub_pmc)
    cant_do_method(interp, pmc, "add_vtable_override");
}
static  void 
Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 624 "./src/pmc/default.pmc"

    STRING * const undef = CONST_STRING(interp, "Undef");

    if (VTABLE_isa(interp, value, undef))
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);
    else
        VTABLE_set_pmc(interp, pmc, value);
#line 646 "./src/pmc/default.c"
}
static  void 
Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 633 "./src/pmc/default.pmc"

    VTABLE_set_string_native(interp, pmc, value);
#line 654 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1901 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_and", "PPP->P", pmc, value, dest, &result);
    return result;
#line 665 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1918 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_and_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 676 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2093 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ands", "PPP->P", pmc, value, dest, &result);
    return result;
#line 687 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2110 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ands_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 698 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2349 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_lsr", "PPP->P", pmc, value, dest, &result);
    return result;
#line 709 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2366 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_lsr_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 720 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, "bitwise_not");
}
static  PMC *
Parrot_default_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, "bitwise_nots");
}
static  PMC  *
Parrot_default_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1837 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_or", "PPP->P", pmc, value, dest, &result);
    return result;
#line 743 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1854 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_or_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 754 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2029 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ors", "PPP->P", pmc, value, dest, &result);
    return result;
#line 765 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2046 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ors_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 776 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2221 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shl", "PPP->P", pmc, value, dest, &result);
    return result;
#line 787 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2238 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shl_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 798 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2285 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shr", "PPP->P", pmc, value, dest, &result);
    return result;
#line 809 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2302 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shr_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 820 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1965 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xor", "PPP->P", pmc, value, dest, &result);
    return result;
#line 831 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1982 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xor_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 842 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2157 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xors", "PPP->P", pmc, value, dest, &result);
    return result;
#line 853 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2174 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xors_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 864 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method)
{
#line 858 "./src/pmc/default.pmc"

    return !PMC_IS_NULL(VTABLE_find_method(interp, pmc, method));
#line 872 "./src/pmc/default.c"
}
static  PMC* 
Parrot_default_clone(PARROT_INTERP, PMC *pmc)
{
#line 1095 "./src/pmc/default.pmc"

    return Parrot_thaw(interp, Parrot_freeze(interp, pmc));
#line 880 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
    UNUSED(args)
    cant_do_method(interp, pmc, "clone_pmc");
}
static  INTVAL 
Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2413 "./src/pmc/default.pmc"

    INTVAL retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp", "PP->I", pmc, value, &retval);

    return retval;
#line 904 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2437 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_num", "PP->I", pmc, value, &retval);

    return retval;
#line 916 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2473 "./src/pmc/default.pmc"

    PMC *retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_pmc", "PP->P", pmc, value, &retval);

    return retval;
#line 934 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2455 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_string", "PP->I", pmc, value, &retval);

    return retval;
#line 946 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2547 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate", "PPP->P", pmc, value, dest, &result);
    return result;
#line 957 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2564 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 968 "./src/pmc/default.c"
}
static  void
Parrot_default_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "decrement");
}
static  INTVAL 
Parrot_default_defined(PARROT_INTERP, PMC *pmc)
{
#line 795 "./src/pmc/default.pmc"

    return 1;
#line 981 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "defined_keyed");
}
static  INTVAL 
Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 810 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_defined_keyed(interp, pmc, r_key);
#line 996 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "defined_keyed_str");
}
static  void
Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "delete_keyed");
}
static  void 
Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 825 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_delete_keyed(interp, pmc, r_key);
#line 1017 "./src/pmc/default.c"
}
static  void
Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "delete_keyed_str");
}
static  void 
Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 419 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        VTABLE_delete_keyed_str(interp, PMC_metadata(pmc), key);
#line 1032 "./src/pmc/default.c"
}
static  void
Parrot_default_destroy(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "destroy");
}
static  PMC  *
Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1453 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1048 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1487 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1059 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1470 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1070 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface)
{
#line 874 "./src/pmc/default.pmc"

    return does_isa(interp, _interface, pmc->vtable->provides_str);
#line 1078 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 888 "./src/pmc/default.pmc"

    UNUSED(role)
    /* No C-level roles yet. */
    return 0;
#line 1088 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_elements(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "elements");
}
static  INTVAL
Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "exists_keyed");
}
static  INTVAL 
Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 780 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_exists_keyed(interp, pmc, r_key);
#line 1108 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "exists_keyed_str");
}
static  PMC  *
Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
#line 510 "./src/pmc/default.pmc"

    return Parrot_find_method_with_cache(interp, pmc, method_name);
#line 1122 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1549 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1133 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1583 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1144 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1566 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1155 "./src/pmc/default.c"
}
static  void 
Parrot_default_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1109 "./src/pmc/default.pmc"

    UNUSED(info)
    /* default - no action */
#line 1164 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name)
{
#line 1030 "./src/pmc/default.pmc"

    UNUSED(key)
    return VTABLE_get_attr_str(interp, pmc, name);
#line 1173 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx)
{
    UNUSED(idx)
    cant_do_method(interp, pmc, "get_attr_str");
}
static  PMC *
Parrot_default_get_bignum(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bignum");
}
static  INTVAL
Parrot_default_get_bool(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bool");
}
static  PMC  *
Parrot_default_get_class(PARROT_INTERP, PMC *pmc)
{
#line 997 "./src/pmc/default.pmc"

    PMC *ns     = VTABLE_get_namespace(interp, pmc);
    PMC *_class = PMCNULL;

    if (!PMC_IS_NULL(ns))
        _class = VTABLE_get_class(interp, ns);

    if (PMC_IS_NULL(_class)) {
        INTVAL type      = VTABLE_type(interp, pmc);
        PMC   *type_num  = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, type_num, type);
        return pmc_new_init(interp, enum_class_PMCProxy, type_num);
    }

    return _class;

#line 1211 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_get_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_integer");
}
static  INTVAL
Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_integer_keyed");
}
static  INTVAL 
Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 529 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_integer_keyed(interp, pmc, r_key);
#line 1231 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_integer_keyed_str");
}
static  PMC *
Parrot_default_get_iter(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_iter");
}
static  PMC  *
Parrot_default_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 496 "./src/pmc/default.pmc"


    /* Because singletons are shared between interpreters, we need to make
     * special effort to use the right namespace for method lookups.
     * Note that this trick won't work if the singleton inherits from
     * something else (because the MRO will still be shared).
     * Having this code here avoids creating a special case for singletons
     * elsewhere.
     */

    return interp->vtables[pmc->vtable->base_type]->_namespace;
#line 1259 "./src/pmc/default.c"
}
static  FLOATVAL
Parrot_default_get_number(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_number");
}
static  FLOATVAL
Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_number_keyed");
}
static  FLOATVAL 
Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 545 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_number_keyed(interp, pmc, r_key);
#line 1279 "./src/pmc/default.c"
}
static  FLOATVAL
Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_number_keyed_str");
}
static  PMC *
Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_pmc");
}
static  PMC *
Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_pmc_keyed");
}
static  PMC  *
Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 578 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_pmc_keyed(interp, pmc, r_key);
#line 1305 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_pmc_keyed_str");
}
static  void  *
Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 593 "./src/pmc/default.pmc"

    return pmc;
#line 1319 "./src/pmc/default.c"
}
static  void *
Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_pointer_keyed");
}
static  void *
Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_pointer_keyed_int");
}
static  void *
Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_pointer_keyed_str");
}
static  STRING *
Parrot_default_get_repr(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_repr");
}
static  STRING *
Parrot_default_get_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_string");
}
static  STRING *
Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_string_keyed");
}
static  STRING  *
Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 562 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_string_keyed(interp, pmc, r_key);
#line 1362 "./src/pmc/default.c"
}
static  STRING *
Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "get_string_keyed_str");
}
static  PMC  *
Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 377 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        return VTABLE_get_pmc_keyed_str(interp, PMC_metadata(pmc), key);
    else
        return check_get_std_props(interp, pmc, key);
#line 1379 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_getprops(PARROT_INTERP, PMC *pmc)
{
#line 434 "./src/pmc/default.pmc"

    if (!pmc->pmc_ext)
        Parrot_gc_add_pmc_ext(interp, pmc);

    if (!PMC_metadata(pmc)) {
        if (has_pending_std_props(pmc))
            return make_prop_hash(interp, pmc);
        else
            return PMCNULL;
    }

    return PMC_metadata(pmc);
#line 1397 "./src/pmc/default.c"
}
static  void
Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_absolute");
}
static  void 
Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1216 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add", "PP", pmc, value);
#line 1411 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1246 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_float", "PN", pmc, value);
#line 1420 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1231 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_int", "PI", pmc, value);
#line 1429 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1935 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_and", "PP", pmc, value);
#line 1438 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1950 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_and_int", "PI", pmc, value);
#line 1447 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2127 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ands", "PP", pmc, value);
#line 1456 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2142 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ands_str", "PS", pmc, value);
#line 1465 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2383 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_lsr", "PP", pmc, value);
#line 1474 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2398 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_lsr_int", "PI", pmc, value);
#line 1483 "./src/pmc/default.c"
}
static  void
Parrot_default_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_not");
}
static  void
Parrot_default_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_nots");
}
static  void 
Parrot_default_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1871 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_or", "PP", pmc, value);
#line 1502 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1886 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_or_int", "PI", pmc, value);
#line 1511 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2063 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ors", "PP", pmc, value);
#line 1520 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2078 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ors_str", "PS", pmc, value);
#line 1529 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2255 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shl", "PP", pmc, value);
#line 1538 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2270 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shl_int", "PI", pmc, value);
#line 1547 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2319 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shr", "PP", pmc, value);
#line 1556 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2334 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shr_int", "PI", pmc, value);
#line 1565 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1999 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xor", "PP", pmc, value);
#line 1574 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2014 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xor_int", "PI", pmc, value);
#line 1583 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2191 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xors", "PP", pmc, value);
#line 1592 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2206 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xors_str", "PS", pmc, value);
#line 1601 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2581 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate", "PP", pmc, value);
#line 1610 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2596 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate_str", "PS", pmc, value);
#line 1619 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1504 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide", "PP", pmc, value);
#line 1628 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1534 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_float", "PN", pmc, value);
#line 1637 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1519 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_int", "PI", pmc, value);
#line 1646 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1600 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide", "PP", pmc, value);
#line 1655 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1630 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_float", "PN", pmc, value);
#line 1664 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1615 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_int", "PI", pmc, value);
#line 1673 "./src/pmc/default.c"
}
static  void
Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_logical_not");
}
static  void 
Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1696 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus", "PP", pmc, value);
#line 1687 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1726 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_float", "PN", pmc, value);
#line 1696 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1711 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_int", "PI", pmc, value);
#line 1705 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1408 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply", "PP", pmc, value);
#line 1714 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1438 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_float", "PN", pmc, value);
#line 1723 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1423 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_int", "PI", pmc, value);
#line 1732 "./src/pmc/default.c"
}
static  void
Parrot_default_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_neg");
}
static  void 
Parrot_default_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1792 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow", "PP", pmc, value);
#line 1746 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1822 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow_float", "PN", pmc, value);
#line 1755 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1807 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow_int", "PI", pmc, value);
#line 1764 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2645 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat", "PP", pmc, value);
#line 1773 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2660 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat_int", "PI", pmc, value);
#line 1782 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1312 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract", "PP", pmc, value);
#line 1791 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1342 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_float", "PN", pmc, value);
#line 1800 "./src/pmc/default.c"
}
static  void 
Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1327 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_int", "PI", pmc, value);
#line 1809 "./src/pmc/default.c"
}
static  void
Parrot_default_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "increment");
}
static  void 
Parrot_default_init(PARROT_INTERP, PMC *pmc)
{
#line 304 "./src/pmc/default.pmc"

#line 1821 "./src/pmc/default.c"
}
static  void 
Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer)
{
#line 317 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(initializer))
        VTABLE_init(interp, pmc);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "init_pmc() not implemented in class '%Ss'",
            caller(interp, pmc));
#line 1834 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_inspect(PARROT_INTERP, PMC *pmc)
{
#line 978 "./src/pmc/default.pmc"

    PMC    *metadata           = pmc_new(interp, enum_class_Hash);
    STRING * const flags_str   = CONST_STRING(interp, "flags");

    VTABLE_set_pmc_keyed_str(interp, metadata, flags_str,
        VTABLE_inspect_str(interp, pmc, flags_str));

    return metadata;
#line 1848 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 953 "./src/pmc/default.pmc"

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "flags"))) {
        PMC *found = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, found,
                (INTVAL)PObj_get_FLAGS(pmc));
        return found;
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "mro"))) {
        return VTABLE_clone(interp, pmc->vtable->mro);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", name);
#line 1867 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 337 "./src/pmc/default.pmc"

    const INTVAL type = VTABLE_type(interp, pmc);

    /* Ensure no looping, as pmc_new calls the instantiate vtable entry for
     * classes. */
    if (PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "All high-level classes should override instantiate");

    if (!PMC_IS_NULL(init))
        return pmc_new_init(interp, type, init);

    return pmc_new(interp, type);
#line 1886 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
    UNUSED(rep)
    UNUSED(flags)
    cant_do_method(interp, pmc, "instantiate_str");
}
static  opcode_t *
Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
    UNUSED(next)
    cant_do_method(interp, pmc, "invoke");
}
static  INTVAL 
Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 725 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal", "PP->I", pmc, value, &retval);

    return retval;
#line 1911 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 743 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_num", "PP->I", pmc, value, &retval);

    return retval;
#line 1923 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 761 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_string", "PP->I", pmc, value, &retval);

    return retval;
#line 1935 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 608 "./src/pmc/default.pmc"

    return pmc == value;
#line 1943 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class)
{
#line 934 "./src/pmc/default.pmc"

    /* RT #46665 - walk mro */
    Hash * const isa_hash = pmc->vtable->isa_hash;
    if (!isa_hash)
        return Parrot_str_equal(interp, pmc->vtable->whoami, _class);

    return parrot_hash_exists(interp, isa_hash, (void *)_class);
#line 1956 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 906 "./src/pmc/default.pmc"

   Hash   * const isa_hash = pmc->vtable->isa_hash;
   STRING *pmc_name;

    if (PMC_IS_NULL(lookup))
        return 0;

    pmc_name = VTABLE_get_string(interp, lookup);

    if (!isa_hash)
        return Parrot_str_equal(interp, pmc->vtable->whoami, pmc_name);

    /* RT #46665 - walk mro */
    return parrot_hash_exists(interp, isa_hash, (void *)pmc_name);
#line 1976 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2513 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_and", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1987 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, "logical_not");
}
static  PMC  *
Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2496 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_or", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2004 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2530 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_xor", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2015 "./src/pmc/default.c"
}
static  void 
Parrot_default_mark(PARROT_INTERP, PMC *pmc)
{
#line 362 "./src/pmc/default.pmc"

    PANIC(interp, "custom_mark flag set but no custom mark routine defined");
#line 2023 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1645 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2034 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1679 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 2045 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1662 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2056 "./src/pmc/default.c"
}
static  void 
Parrot_default_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
#line 647 "./src/pmc/default.pmc"

    pmc_reuse(interp, pmc, VTABLE_get_integer(interp, type), 0);
#line 2064 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1357 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2075 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1391 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 2086 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1374 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2097 "./src/pmc/default.c"
}
static  STRING  *
Parrot_default_name(PARROT_INTERP, PMC *pmc)
{
#line 472 "./src/pmc/default.pmc"

    return pmc->vtable->whoami;
#line 2105 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    UNUSED(dest)
    cant_do_method(interp, pmc, "neg");
}
static  PMC *
Parrot_default_nextkey_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL what)
{
    UNUSED(key)
    UNUSED(what)
    cant_do_method(interp, pmc, "nextkey_keyed");
}
static  PMC  *
Parrot_default_nextkey_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL w)
{
#line 841 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_nextkey_keyed(interp, pmc, r_key, w);
#line 2127 "./src/pmc/default.c"
}
static  PMC *
Parrot_default_nextkey_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL what)
{
    UNUSED(key)
    UNUSED(what)
    cant_do_method(interp, pmc, "nextkey_keyed_str");
}
static  FLOATVAL
Parrot_default_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_float");
}
static  INTVAL
Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_integer");
}
static  PMC *
Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_pmc");
}
static  STRING *
Parrot_default_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_string");
}
static  PMC  *
Parrot_default_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1741 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2165 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1775 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 2176 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1758 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2187 "./src/pmc/default.c"
}
static  void
Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "push_float");
}
static  void
Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "push_integer");
}
static  void
Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "push_pmc");
}
static  void
Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "push_string");
}
static  void
Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    UNUSED(name)
    cant_do_method(interp, pmc, "remove_attribute");
}
static  void
Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    UNUSED(method_name)
    cant_do_method(interp, pmc, "remove_method");
}
static  void
Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_method(interp, pmc, "remove_parent");
}
static  void
Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_method(interp, pmc, "remove_role");
}
static  void
Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    UNUSED(vtable_name)
    cant_do_method(interp, pmc, "remove_vtable_override");
}
static  PMC  *
Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2611 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2252 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2628 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2263 "./src/pmc/default.c"
}
static  void 
Parrot_default_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value)
{
#line 1035 "./src/pmc/default.pmc"

    UNUSED(key)
    VTABLE_set_attr_str(interp, pmc, name, value);
#line 2272 "./src/pmc/default.c"
}
static  void
Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    UNUSED(idx)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_attr_str");
}
static  void
Parrot_default_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_bignum_int");
}
static  void
Parrot_default_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_bignum_num");
}
static  void
Parrot_default_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_bignum_str");
}
static  void
Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_bool");
}
static  void
Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_integer_keyed");
}
static  void 
Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 662 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_integer_keyed(interp, pmc, r_key, value);
#line 2319 "./src/pmc/default.c"
}
static  void
Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_integer_keyed_str");
}
static  void
Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_integer_native");
}
static  void
Parrot_default_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_integer_same");
}
static  void
Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_number_keyed");
}
static  void 
Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 678 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_number_keyed(interp, pmc, r_key, value);
#line 2354 "./src/pmc/default.c"
}
static  void
Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_number_keyed_str");
}
static  void
Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_number_native");
}
static  void
Parrot_default_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_number_same");
}
static  void
Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pmc");
}
static  void
Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pmc_keyed");
}
static  void 
Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 710 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_pmc_keyed(interp, pmc, r_key, value);
#line 2395 "./src/pmc/default.c"
}
static  void
Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pmc_keyed_str");
}
static  void
Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pointer");
}
static  void
Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pointer_keyed");
}
static  void
Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pointer_keyed_int");
}
static  void
Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_pointer_keyed_str");
}
static  void
Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_string_keyed");
}
static  void 
Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string)
{
#line 694 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_string_keyed(interp, pmc, r_key, string);
#line 2445 "./src/pmc/default.c"
}
static  void
Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_method(interp, pmc, "set_string_keyed_str");
}
static  void
Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_string_native");
}
static  void
Parrot_default_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "set_string_same");
}
static  void 
Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 394 "./src/pmc/default.pmc"

    if (check_set_std_props(interp, pmc, key, value))
        return;

    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_set_pmc_keyed_str(interp,
            PMC_metadata(pmc), key, value);
    }
    else {
        PMC * const prop = make_prop_hash(interp, pmc);

        VTABLE_set_pmc_keyed_str(interp, prop, key, value);
    }
#line 2483 "./src/pmc/default.c"
}
static  void
Parrot_default_share(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share");
}
static  PMC *
Parrot_default_share_ro(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share_ro");
}
static  FLOATVAL
Parrot_default_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_float");
}
static  INTVAL
Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_integer");
}
static  PMC *
Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_pmc");
}
static  STRING *
Parrot_default_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_string");
}
static  PMC *
Parrot_default_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag)
{
    UNUSED(key)
    UNUSED(flag)
    cant_do_method(interp, pmc, "slice");
}
static  void
Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    UNUSED(value)
    UNUSED(offset)
    UNUSED(count)
    cant_do_method(interp, pmc, "splice");
}
static  void
Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest)
{
    UNUSED(offset)
    UNUSED(length)
    UNUSED(dest)
    cant_do_method(interp, pmc, "substr");
}
static  STRING *
Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
    UNUSED(offset)
    UNUSED(length)
    cant_do_method(interp, pmc, "substr_str");
}
static  PMC  *
Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1261 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2554 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1295 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 2565 "./src/pmc/default.c"
}
static  PMC  *
Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1278 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2576 "./src/pmc/default.c"
}
static  void 
Parrot_default_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1124 "./src/pmc/default.pmc"

    /* default - initialize the PMC */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        if (!pmc->pmc_ext)
            Parrot_gc_add_pmc_ext(interp, pmc);

        info->thaw_ptr  = &PMC_metadata(pmc);
        info->container = pmc;

        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
    else
        VTABLE_init(interp, pmc);
#line 2595 "./src/pmc/default.c"
}
static  void 
Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1149 "./src/pmc/default.pmc"

    UNUSED(info)
    /* default - no action */
#line 2604 "./src/pmc/default.c"
}
static  INTVAL 
Parrot_default_type(PARROT_INTERP, PMC *pmc)
{
#line 458 "./src/pmc/default.pmc"

    return pmc->vtable->base_type;
#line 2612 "./src/pmc/default.c"
}
static  INTVAL
Parrot_default_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_method(interp, pmc, "type_keyed");
}
static  void
Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "unshift_float");
}
static  void
Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "unshift_integer");
}
static  void
Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "unshift_pmc");
}
static  void
Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_method(interp, pmc, "unshift_string");
}
static  void 
Parrot_default_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1070 "./src/pmc/default.pmc"

    /* default - mark prop hash */
    if (pmc->pmc_ext && PMC_metadata(pmc) &&
        info->extra_flags != EXTRA_IS_PROP_HASH) {
        info->extra_flags = EXTRA_IS_PROP_HASH;
        info->extra       = PMC_metadata(pmc);

        /* place escape mark */
        (info->visit_pmc_now)(interp, pmc, info);

        /* place and the prop hash */
        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
#line 2661 "./src/pmc/default.c"
}
static  void
Parrot_default_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    UNUSED(name)
    UNUSED(type)
    cant_do_write_method(interp, pmc, "add_attribute");
}
static  void
Parrot_default_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    UNUSED(method_name)
    UNUSED(sub_pmc)
    cant_do_write_method(interp, pmc, "add_method");
}
static  void
Parrot_default_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_write_method(interp, pmc, "add_parent");
}
static  void
Parrot_default_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_write_method(interp, pmc, "add_role");
}
static  void
Parrot_default_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    UNUSED(vtable_name)
    UNUSED(sub_pmc)
    cant_do_write_method(interp, pmc, "add_vtable_override");
}
static  void
Parrot_default_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "assign_pmc");
}
static  void
Parrot_default_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "assign_string_native");
}
static  void
Parrot_default_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "decrement");
}
static  void
Parrot_default_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, "delete_keyed");
}
static  void
Parrot_default_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, "delete_keyed_int");
}
static  void
Parrot_default_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    UNUSED(key)
    cant_do_write_method(interp, pmc, "delete_keyed_str");
}
static  PMC *
Parrot_default_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name) {
    /* Use non-readonly find_method. Current vtable is ro variant. So ro_variant contains non-ro variant */
    PMC *const method = pmc->vtable->ro_variant_vtable->find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
static  void
Parrot_default_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "i_absolute");
}
static  void
Parrot_default_ro_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_add");
}
static  void
Parrot_default_ro_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_add_float");
}
static  void
Parrot_default_ro_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_add_int");
}
static  void
Parrot_default_ro_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_and");
}
static  void
Parrot_default_ro_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_and_int");
}
static  void
Parrot_default_ro_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_ands");
}
static  void
Parrot_default_ro_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_ands_str");
}
static  void
Parrot_default_ro_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_lsr");
}
static  void
Parrot_default_ro_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_lsr_int");
}
static  void
Parrot_default_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "i_bitwise_not");
}
static  void
Parrot_default_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "i_bitwise_nots");
}
static  void
Parrot_default_ro_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_or");
}
static  void
Parrot_default_ro_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_or_int");
}
static  void
Parrot_default_ro_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_ors");
}
static  void
Parrot_default_ro_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_ors_str");
}
static  void
Parrot_default_ro_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_shl");
}
static  void
Parrot_default_ro_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_shl_int");
}
static  void
Parrot_default_ro_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_shr");
}
static  void
Parrot_default_ro_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_shr_int");
}
static  void
Parrot_default_ro_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_xor");
}
static  void
Parrot_default_ro_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_xor_int");
}
static  void
Parrot_default_ro_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_xors");
}
static  void
Parrot_default_ro_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_bitwise_xors_str");
}
static  void
Parrot_default_ro_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_concatenate");
}
static  void
Parrot_default_ro_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_concatenate_str");
}
static  void
Parrot_default_ro_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_divide");
}
static  void
Parrot_default_ro_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_divide_float");
}
static  void
Parrot_default_ro_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_divide_int");
}
static  void
Parrot_default_ro_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_floor_divide");
}
static  void
Parrot_default_ro_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_floor_divide_float");
}
static  void
Parrot_default_ro_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_floor_divide_int");
}
static  void
Parrot_default_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "i_logical_not");
}
static  void
Parrot_default_ro_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_modulus");
}
static  void
Parrot_default_ro_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_modulus_float");
}
static  void
Parrot_default_ro_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_modulus_int");
}
static  void
Parrot_default_ro_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_multiply");
}
static  void
Parrot_default_ro_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_multiply_float");
}
static  void
Parrot_default_ro_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_multiply_int");
}
static  void
Parrot_default_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "i_neg");
}
static  void
Parrot_default_ro_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_pow");
}
static  void
Parrot_default_ro_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_pow_float");
}
static  void
Parrot_default_ro_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_pow_int");
}
static  void
Parrot_default_ro_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_repeat");
}
static  void
Parrot_default_ro_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_repeat_int");
}
static  void
Parrot_default_ro_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_subtract");
}
static  void
Parrot_default_ro_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_subtract_float");
}
static  void
Parrot_default_ro_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "i_subtract_int");
}
static  void
Parrot_default_ro_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "increment");
}
static  void
Parrot_default_ro_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
    UNUSED(type)
    cant_do_write_method(interp, pmc, "morph");
}
static  FLOATVAL
Parrot_default_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "pop_float");
}
static  INTVAL
Parrot_default_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "pop_integer");
}
static  PMC *
Parrot_default_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "pop_pmc");
}
static  STRING *
Parrot_default_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "pop_string");
}
static  void
Parrot_default_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "push_float");
}
static  void
Parrot_default_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "push_integer");
}
static  void
Parrot_default_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "push_pmc");
}
static  void
Parrot_default_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "push_string");
}
static  void
Parrot_default_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    UNUSED(name)
    cant_do_write_method(interp, pmc, "remove_attribute");
}
static  void
Parrot_default_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    UNUSED(method_name)
    cant_do_write_method(interp, pmc, "remove_method");
}
static  void
Parrot_default_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    UNUSED(parent)
    cant_do_write_method(interp, pmc, "remove_parent");
}
static  void
Parrot_default_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    UNUSED(role)
    cant_do_write_method(interp, pmc, "remove_role");
}
static  void
Parrot_default_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    UNUSED(vtable_name)
    cant_do_write_method(interp, pmc, "remove_vtable_override");
}
static  void
Parrot_default_ro_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *idx, PMC *value)
{
    UNUSED(key)
    UNUSED(idx)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_attr_keyed");
}
static  void
Parrot_default_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    UNUSED(idx)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_attr_str");
}
static  void
Parrot_default_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_bignum_int");
}
static  void
Parrot_default_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_bignum_num");
}
static  void
Parrot_default_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_bignum_str");
}
static  void
Parrot_default_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_bool");
}
static  void
Parrot_default_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_integer_keyed");
}
static  void
Parrot_default_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_integer_keyed_int");
}
static  void
Parrot_default_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_integer_keyed_str");
}
static  void
Parrot_default_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_integer_native");
}
static  void
Parrot_default_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_integer_same");
}
static  void
Parrot_default_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_number_keyed");
}
static  void
Parrot_default_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_number_keyed_int");
}
static  void
Parrot_default_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_number_keyed_str");
}
static  void
Parrot_default_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_number_native");
}
static  void
Parrot_default_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_number_same");
}
static  void
Parrot_default_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pmc");
}
static  void
Parrot_default_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pmc_keyed");
}
static  void
Parrot_default_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pmc_keyed_int");
}
static  void
Parrot_default_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pmc_keyed_str");
}
static  void
Parrot_default_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pointer");
}
static  void
Parrot_default_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pointer_keyed");
}
static  void
Parrot_default_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pointer_keyed_int");
}
static  void
Parrot_default_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_pointer_keyed_str");
}
static  void
Parrot_default_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_string_keyed");
}
static  void
Parrot_default_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_string_keyed_int");
}
static  void
Parrot_default_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    UNUSED(key)
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_string_keyed_str");
}
static  void
Parrot_default_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_string_native");
}
static  void
Parrot_default_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "set_string_same");
}
static  FLOATVAL
Parrot_default_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "shift_float");
}
static  INTVAL
Parrot_default_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "shift_integer");
}
static  PMC *
Parrot_default_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "shift_pmc");
}
static  STRING *
Parrot_default_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_write_method(interp, pmc, "shift_string");
}
static  void
Parrot_default_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    UNUSED(value)
    UNUSED(offset)
    UNUSED(count)
    cant_do_write_method(interp, pmc, "splice");
}
static  void
Parrot_default_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    UNUSED(info)
    cant_do_write_method(interp, pmc, "thaw");
}
static  void
Parrot_default_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    UNUSED(info)
    cant_do_write_method(interp, pmc, "thawfinish");
}
static  void
Parrot_default_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "unshift_float");
}
static  void
Parrot_default_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "unshift_integer");
}
static  void
Parrot_default_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "unshift_pmc");
}
static  void
Parrot_default_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    UNUSED(value)
    cant_do_write_method(interp, pmc, "unshift_string");
}
#include "pmc_default.h"

PARROT_EXPORT VTABLE* Parrot_default_get_vtable(PARROT_INTERP) {

    static const char attr_defs [] = "";

    const VTABLE temp_vtable = {
        NULL,       /* namespace */
        enum_class_default, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        NULL,       /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };


    return Parrot_clone_vtable(interp, &temp_vtable);
}


PARROT_EXPORT VTABLE* Parrot_default_ro_get_vtable(PARROT_INTERP) {

    VTABLE * vt = Parrot_default_get_vtable(interp);

    vt->add_attribute = Parrot_default_ro_add_attribute;
    vt->add_method = Parrot_default_ro_add_method;
    vt->add_parent = Parrot_default_ro_add_parent;
    vt->add_role = Parrot_default_ro_add_role;
    vt->add_vtable_override = Parrot_default_ro_add_vtable_override;
    vt->assign_pmc = Parrot_default_ro_assign_pmc;
    vt->assign_string_native = Parrot_default_ro_assign_string_native;
    vt->decrement = Parrot_default_ro_decrement;
    vt->delete_keyed = Parrot_default_ro_delete_keyed;
    vt->delete_keyed_int = Parrot_default_ro_delete_keyed_int;
    vt->delete_keyed_str = Parrot_default_ro_delete_keyed_str;
    vt->find_method = Parrot_default_ro_find_method;
    vt->i_absolute = Parrot_default_ro_i_absolute;
    vt->i_add = Parrot_default_ro_i_add;
    vt->i_add_float = Parrot_default_ro_i_add_float;
    vt->i_add_int = Parrot_default_ro_i_add_int;
    vt->i_bitwise_and = Parrot_default_ro_i_bitwise_and;
    vt->i_bitwise_and_int = Parrot_default_ro_i_bitwise_and_int;
    vt->i_bitwise_ands = Parrot_default_ro_i_bitwise_ands;
    vt->i_bitwise_ands_str = Parrot_default_ro_i_bitwise_ands_str;
    vt->i_bitwise_lsr = Parrot_default_ro_i_bitwise_lsr;
    vt->i_bitwise_lsr_int = Parrot_default_ro_i_bitwise_lsr_int;
    vt->i_bitwise_not = Parrot_default_ro_i_bitwise_not;
    vt->i_bitwise_nots = Parrot_default_ro_i_bitwise_nots;
    vt->i_bitwise_or = Parrot_default_ro_i_bitwise_or;
    vt->i_bitwise_or_int = Parrot_default_ro_i_bitwise_or_int;
    vt->i_bitwise_ors = Parrot_default_ro_i_bitwise_ors;
    vt->i_bitwise_ors_str = Parrot_default_ro_i_bitwise_ors_str;
    vt->i_bitwise_shl = Parrot_default_ro_i_bitwise_shl;
    vt->i_bitwise_shl_int = Parrot_default_ro_i_bitwise_shl_int;
    vt->i_bitwise_shr = Parrot_default_ro_i_bitwise_shr;
    vt->i_bitwise_shr_int = Parrot_default_ro_i_bitwise_shr_int;
    vt->i_bitwise_xor = Parrot_default_ro_i_bitwise_xor;
    vt->i_bitwise_xor_int = Parrot_default_ro_i_bitwise_xor_int;
    vt->i_bitwise_xors = Parrot_default_ro_i_bitwise_xors;
    vt->i_bitwise_xors_str = Parrot_default_ro_i_bitwise_xors_str;
    vt->i_concatenate = Parrot_default_ro_i_concatenate;
    vt->i_concatenate_str = Parrot_default_ro_i_concatenate_str;
    vt->i_divide = Parrot_default_ro_i_divide;
    vt->i_divide_float = Parrot_default_ro_i_divide_float;
    vt->i_divide_int = Parrot_default_ro_i_divide_int;
    vt->i_floor_divide = Parrot_default_ro_i_floor_divide;
    vt->i_floor_divide_float = Parrot_default_ro_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_default_ro_i_floor_divide_int;
    vt->i_logical_not = Parrot_default_ro_i_logical_not;
    vt->i_modulus = Parrot_default_ro_i_modulus;
    vt->i_modulus_float = Parrot_default_ro_i_modulus_float;
    vt->i_modulus_int = Parrot_default_ro_i_modulus_int;
    vt->i_multiply = Parrot_default_ro_i_multiply;
    vt->i_multiply_float = Parrot_default_ro_i_multiply_float;
    vt->i_multiply_int = Parrot_default_ro_i_multiply_int;
    vt->i_neg = Parrot_default_ro_i_neg;
    vt->i_pow = Parrot_default_ro_i_pow;
    vt->i_pow_float = Parrot_default_ro_i_pow_float;
    vt->i_pow_int = Parrot_default_ro_i_pow_int;
    vt->i_repeat = Parrot_default_ro_i_repeat;
    vt->i_repeat_int = Parrot_default_ro_i_repeat_int;
    vt->i_subtract = Parrot_default_ro_i_subtract;
    vt->i_subtract_float = Parrot_default_ro_i_subtract_float;
    vt->i_subtract_int = Parrot_default_ro_i_subtract_int;
    vt->increment = Parrot_default_ro_increment;
    vt->morph = Parrot_default_ro_morph;
    vt->pop_float = Parrot_default_ro_pop_float;
    vt->pop_integer = Parrot_default_ro_pop_integer;
    vt->pop_pmc = Parrot_default_ro_pop_pmc;
    vt->pop_string = Parrot_default_ro_pop_string;
    vt->push_float = Parrot_default_ro_push_float;
    vt->push_integer = Parrot_default_ro_push_integer;
    vt->push_pmc = Parrot_default_ro_push_pmc;
    vt->push_string = Parrot_default_ro_push_string;
    vt->remove_attribute = Parrot_default_ro_remove_attribute;
    vt->remove_method = Parrot_default_ro_remove_method;
    vt->remove_parent = Parrot_default_ro_remove_parent;
    vt->remove_role = Parrot_default_ro_remove_role;
    vt->remove_vtable_override = Parrot_default_ro_remove_vtable_override;
    vt->set_attr_keyed = Parrot_default_ro_set_attr_keyed;
    vt->set_attr_str = Parrot_default_ro_set_attr_str;
    vt->set_bignum_int = Parrot_default_ro_set_bignum_int;
    vt->set_bignum_num = Parrot_default_ro_set_bignum_num;
    vt->set_bignum_str = Parrot_default_ro_set_bignum_str;
    vt->set_bool = Parrot_default_ro_set_bool;
    vt->set_integer_keyed = Parrot_default_ro_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_default_ro_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_default_ro_set_integer_keyed_str;
    vt->set_integer_native = Parrot_default_ro_set_integer_native;
    vt->set_integer_same = Parrot_default_ro_set_integer_same;
    vt->set_number_keyed = Parrot_default_ro_set_number_keyed;
    vt->set_number_keyed_int = Parrot_default_ro_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_default_ro_set_number_keyed_str;
    vt->set_number_native = Parrot_default_ro_set_number_native;
    vt->set_number_same = Parrot_default_ro_set_number_same;
    vt->set_pmc = Parrot_default_ro_set_pmc;
    vt->set_pmc_keyed = Parrot_default_ro_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_default_ro_set_pmc_keyed_int;
    vt->set_pmc_keyed_str = Parrot_default_ro_set_pmc_keyed_str;
    vt->set_pointer = Parrot_default_ro_set_pointer;
    vt->set_pointer_keyed = Parrot_default_ro_set_pointer_keyed;
    vt->set_pointer_keyed_int = Parrot_default_ro_set_pointer_keyed_int;
    vt->set_pointer_keyed_str = Parrot_default_ro_set_pointer_keyed_str;
    vt->set_string_keyed = Parrot_default_ro_set_string_keyed;
    vt->set_string_keyed_int = Parrot_default_ro_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_default_ro_set_string_keyed_str;
    vt->set_string_native = Parrot_default_ro_set_string_native;
    vt->set_string_same = Parrot_default_ro_set_string_same;
    vt->shift_float = Parrot_default_ro_shift_float;
    vt->shift_integer = Parrot_default_ro_shift_integer;
    vt->shift_pmc = Parrot_default_ro_shift_pmc;
    vt->shift_string = Parrot_default_ro_shift_string;
    vt->splice = Parrot_default_ro_splice;
    vt->thaw = Parrot_default_ro_thaw;
    vt->thawfinish = Parrot_default_ro_thawfinish;
    vt->unshift_float = Parrot_default_ro_unshift_float;
    vt->unshift_integer = Parrot_default_ro_unshift_integer;
    vt->unshift_pmc = Parrot_default_ro_unshift_pmc;
    vt->unshift_string = Parrot_default_ro_unshift_string;


    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_default_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "default", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_default_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "default")), PMCNULL);
    return isa;
}

void
Parrot_default_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_default_get_vtable(interp);
        vt->base_type      = enum_class_default;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "default");
        vt->provides_str = CONST_STRING_GEN(interp, "");
        vt->isa_hash     = NULL;
    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_default_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_default_class_init */
#line 2663 "./src/pmc/default.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
