/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: hash.pmc 40136 2009-07-17 14:34:11Z particle $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

Hash PMC wraps Parrot's _hash to provide high-level API:

=over 4

=item *

Convert between various types to use as hash keys.

=item *

Convert between various types to use as hash values.

=item *

Handle compound Keys for nested Hash/Array lookups.

=item *

Provide C<HashIterator> to iterate over C<Hash>.

=back

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "pmc_iterator.h"
#include "pmc_key.h"
#include "pmc_hashiteratorkey.h"

/*

=item C<static PMC *get_integer_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing native integers.

=cut

*/

static PMC *get_integer_pmc(PARROT_INTERP) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
}


/*

=item C<static PMC *get_number_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for floating point numbers.

=cut

*/

static PMC *get_number_pmc(PARROT_INTERP) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
}

/*

=item C<static PMC *get_string_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing strings.

=cut

*/

static PMC *get_string_pmc(PARROT_INTERP) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
}


/*

Poor-man polymorphic functions to convert something to something.

There is bunch of functions to convert from passed value to stored keys type and to/from
stored values type.

void *hash_key_from_TYPE convert to keys type.
void *hash_value_from_TYPE convert to values type.
TYPE hash_value_to_TYPE convert from values type.

*/

static void*
hash_key_from_int(PARROT_INTERP, const Hash * const hash, INTVAL key)
{
    void *ret;
    switch (hash->key_type) {
        case Hash_key_type_int:
            ret = (void *)key;
            break;
        /* Currently PMCs are stringified */
        case Hash_key_type_PMC:
        case Hash_key_type_STRING:
            ret = (void *)Parrot_str_from_int(interp, key);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported key_type");
    }
    return ret;
}

static void*
hash_key_from_string(PARROT_INTERP, const Hash * const hash, ARGIN(STRING *key))
{
    void *ret;
    switch (hash->key_type) {
        case Hash_key_type_int:
        {
            /* Pacify compiler about casting INVTAL to void */
            const INTVAL int_key = Parrot_str_to_int(interp, key);
            ret                  = INTVAL2PTR(void *, int_key);
            break;
        }
        /* Currently PMCs are stringified */
        case Hash_key_type_PMC:
        case Hash_key_type_STRING:
            ret = key;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported key_type");
    }
    return ret;
}

static void*
hash_key_from_pmc(PARROT_INTERP, const Hash * const hash, ARGIN(PMC *key))
{
    void *ret;
    switch (hash->key_type) {
        case Hash_key_type_int:
        {
            const INTVAL int_key = VTABLE_get_integer(interp, key);
            ret                  = INTVAL2PTR(void *, int_key);
            break;
        }
        /* Currently PMCs are stringified */
        case Hash_key_type_PMC:
        case Hash_key_type_STRING:
            {
                STRING * const tmp = VTABLE_get_string(interp, key);
                if (!tmp)
                    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
                            "hash: can't use null as key");
                ret = (void *)tmp;
            }
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported key_type");
    }
    return ret;
}


/* Second part - convert from stored void* to real type */
/* TODO: FLOATVALs converted into Float PMC for now */
static void*
hash_value_from_int(PARROT_INTERP, const Hash * const hash, INTVAL value)
{
    void *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            ret = INTVAL2PTR(void *, value);
            break;
        case enum_type_PMC:
            {
                PMC * const tmp = get_integer_pmc(interp);
                VTABLE_set_integer_native(interp, tmp, value);
                ret = INTVAL2PTR(void *, tmp);
            }
            break;
        case enum_type_STRING:
            ret = (void *)Parrot_str_from_int(interp, value);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static void*
hash_value_from_string(PARROT_INTERP, const Hash * const hash, STRING *value)
{
    void *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
        {
            const INTVAL int_val = Parrot_str_to_int(interp, value);
            ret                  = INTVAL2PTR(void *, int_val);
            break;
        }
        case enum_type_STRING:
            ret = (void *)value;
            break;
        case enum_type_PMC:
            {
                PMC * const s = get_string_pmc(interp);
                VTABLE_set_string_native(interp, s, value);
                ret = (void *)s;
            }
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static void*
hash_value_from_pmc(PARROT_INTERP, const Hash * const hash, PMC *value)
{
    void *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
        {
            const INTVAL int_val = VTABLE_get_integer(interp, value);
            ret                  = INTVAL2PTR(void *, int_val);
            break;
        }
        case enum_type_STRING:
            ret = (void *)VTABLE_get_string(interp, value);
            break;
        case enum_type_PMC:
            ret = (void *)value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static void*
hash_value_from_number(PARROT_INTERP, const Hash * const hash, FLOATVAL value)
{
    void *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            {
                const INTVAL tmp = value;
                ret = (void*)tmp;
            }
            break;
        case enum_type_STRING:
            ret = (void *)Parrot_str_from_num(interp, value);
            break;
        case enum_type_PMC:
            {
                PMC * const tmp = get_number_pmc(interp);
                VTABLE_set_number_native(interp, tmp, value);
                ret = (void *)tmp;
            }
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static INTVAL
hash_value_to_int(PARROT_INTERP, const Hash * const hash, void *value)
{
    INTVAL ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            ret = (INTVAL)value;
            break;
        case enum_type_STRING:
            ret = Parrot_str_to_int(interp, (STRING*)value);
            break;
        case enum_type_PMC:
            ret = VTABLE_get_integer(interp, (PMC*)value);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static STRING*
hash_value_to_string(PARROT_INTERP, const Hash * const hash, void *value)
{
    STRING *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            ret = Parrot_str_from_int(interp, (INTVAL)value);
            break;
        case enum_type_STRING:
            ret = (STRING *)value;
            break;
        case enum_type_PMC:
            ret = VTABLE_get_string(interp, (PMC *)value);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static PMC*
hash_value_to_pmc(PARROT_INTERP, const Hash * const hash, void *value)
{
    PMC *ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            ret = get_integer_pmc(interp);
            VTABLE_set_integer_native(interp, ret, (INTVAL)value);
            break;
        case enum_type_STRING:
            ret = get_string_pmc(interp);
            VTABLE_set_string_native(interp, ret, (STRING *)value);
            break;
        case enum_type_PMC:
            ret = (PMC *)value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}

static FLOATVAL
hash_value_to_number(PARROT_INTERP, const Hash * const hash, void *value)
{
    FLOATVAL ret;
    switch (hash->entry_type) {
        case enum_type_INTVAL:
            {
                /* Pacify compiler about casting */
                const INTVAL tmp = (INTVAL)value;
                ret = tmp;
            }
            break;
        case enum_type_STRING:
            ret = Parrot_str_to_num(interp, (STRING*)value);
            break;
        case enum_type_PMC:
            ret = VTABLE_get_number(interp, (PMC*)value);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }
    return ret;
}


/* Needs ext struct for the next_for_GC pointer
 * We would get recursive marking of a deeply nested HoHoH...
 */
#line 401 "./src/pmc/hash.c"
static  PMC  * Parrot_Hash_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Hash_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Hash_freeze(PARROT_INTERP, PMC *pmc, visit_info *info);
static  INTVAL  Parrot_Hash_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  INTVAL  Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_Hash_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Hash_get_number(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  FLOATVAL  Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  PMC  * Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  PMC  * Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  * Parrot_Hash_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Hash_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Hash_get_string(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key);
static  STRING  * Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key);
static  void  Parrot_Hash_init(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Hash_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Hash_is_same(PARROT_INTERP, PMC *pmc, PMC *other);
static  void  Parrot_Hash_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value);
static  void  Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value);
static  void  Parrot_Hash_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL type);
static  void  Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value);
static  void  Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value);
static  void  Parrot_Hash_set_pointer(PARROT_INTERP, PMC *pmc, void *ptr);
static  void  Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value);
static  void  Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value);
static  PMC  * Parrot_Hash_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f);
static  void  Parrot_Hash_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void  Parrot_Hash_visit(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void Parrot_Hash_nci_set_key_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_Hash_nci_get_key_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_Hash_nci_set_value_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_Hash_nci_get_value_type(PARROT_INTERP, PMC *pmc);
void    Parrot_Hash_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP);
void    Parrot_Hash_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Hash_clone(PARROT_INTERP, PMC *pmc)
{
#line 439 "./src/pmc/hash.pmc"

    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);

    parrot_hash_clone(interp, (Hash *)VTABLE_get_pointer(interp, pmc),
               (Hash *)VTABLE_get_pointer(interp, dest));

    return dest;
#line 471 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1190 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, pmc);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = key_next(interp, key);

    if (!key)
        return VTABLE_defined(interp, hash_value_to_pmc(interp, h, b->value));
    else
        return VTABLE_defined_keyed(interp,
                hash_value_to_pmc(interp, h, b->value), key);
#line 493 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1168 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    /* no such key */
    if (!b)
        return 0;

    return VTABLE_defined(interp, hash_value_to_pmc(interp, hash, b->value));
#line 509 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1231 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, pmc);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return;

    key = key_next(interp, key);

    if (!key)
        parrot_hash_delete(interp, h, sx);
    else
        VTABLE_delete_keyed(interp, (PMC *)b->value, key);
#line 530 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1216 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_delete(interp, hash, hash_key_from_string(interp, hash, key));
#line 539 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_destroy(PARROT_INTERP, PMC *pmc)
{
#line 406 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    if (hash)
        parrot_hash_destroy(interp, hash);

    mem_sys_free(PMC_data(pmc));
#line 551 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_elements(PARROT_INTERP, PMC *pmc)
{
#line 1272 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, pmc));
#line 559 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1142 "./src/pmc/hash.pmc"

    Hash       * const h  = (Hash *)VTABLE_get_pointer(interp, pmc);
    void       * const sx = hash_key_from_pmc(interp, h, key);
    HashBucket * const b  = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    key = key_next(interp, key);

    /* lookup stops here */
    if (!key)
        return 1;

    return VTABLE_exists_keyed(interp, hash_value_to_pmc(interp, h, b->value), key);
#line 581 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 1125 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));
    return b != NULL;
#line 592 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1398 "./src/pmc/hash.pmc"

    IMAGE_IO * const io   = info->image_io;
    Hash     * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);;

    interp->vtables[enum_class_default]->freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
    VTABLE_push_integer(interp, io, (INTVAL)hash->key_type);
    VTABLE_push_integer(interp, io, hash->entry_type);
#line 606 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 1258 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, pmc)) != 0;
#line 614 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 590 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, pmc));
#line 622 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 701 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return VTABLE_get_integer(interp, valpmc);

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_integer_keyed(interp, valpmc, nextkey);
#line 647 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 680 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return 0;

    return hash_value_to_int(interp, hash, b->value);
#line 662 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 669 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return 0;

    return hash_value_to_int(interp, hash, b->value);
#line 677 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 1286 "./src/pmc/hash.pmc"

    return pmc_new_init(interp, enum_class_HashIterator, pmc);
#line 685 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number(PARROT_INTERP, PMC *pmc)
{
#line 594 "./src/pmc/hash.pmc"

    return VTABLE_get_integer(interp, pmc);
#line 693 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 819 "./src/pmc/hash.pmc"

    PMC               *nextkey;
    PMC               *valpmc;
    const Hash * const hash   = (Hash *)VTABLE_get_pointer(interp, pmc);
    void       * const keystr = hash_key_from_pmc(interp, hash, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return 0.0;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    if (!nextkey)
        return VTABLE_get_number(interp, valpmc);

    return VTABLE_get_number_keyed(interp, valpmc, nextkey);
#line 716 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 798 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return 0.0;

    return hash_value_to_number(interp, hash, b->value);
#line 731 "./src/pmc/hash.c"
}
static  FLOATVAL 
Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 787 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return 0.0;

    return hash_value_to_number(interp, hash, b->value);
#line 746 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 995 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return PMCNULL;

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return valpmc;

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_pmc_keyed(interp, valpmc, nextkey);
#line 771 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 983 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b    = parrot_hash_get_bucket(interp, hash,
            hash_key_from_int(interp, hash, key));

    if (!b)
        return PMCNULL;

    return hash_value_to_pmc(interp, hash, b->value);
#line 786 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 972 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b    = parrot_hash_get_bucket(interp, hash,
            hash_key_from_string(interp, hash, key));

    if (!b)
        return PMCNULL;

    return hash_value_to_pmc(interp, hash, b->value);
#line 801 "./src/pmc/hash.c"
}
static  void  *
Parrot_Hash_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 574 "./src/pmc/hash.pmc"

    return PARROT_HASH(pmc)->hash;
#line 809 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 617 "./src/pmc/hash.pmc"

    /* RT #44643 use freeze */
    PMC * const  iter = VTABLE_get_iter(interp, pmc);
    STRING      *res  = CONST_STRING(interp, "{");
    const INTVAL n    = VTABLE_elements(interp, pmc);
    INTVAL       j;

    for (j = 0; j < n; ++j) {
        STRING * const key       = VTABLE_shift_string(interp, iter);
        int            all_digit = 1;
        int            i;
        PMC           *val;

        for (i = 0; i < (int)key->strlen; ++i) {
            if (!isdigit((unsigned char)((const char *)key->strstart)[i])) {
                all_digit = 0;
                break;
            }
        }

        if (all_digit) {
            res = Parrot_str_append(interp, res, key);
        }
        else {
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "'"));
            res = Parrot_str_append(interp, res, key);
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "'"));
        }

        res = Parrot_str_append(interp, res, CONST_STRING(interp, ": "));
        val = VTABLE_get_pmc_keyed_str(interp, pmc, key);
        res = Parrot_str_append(interp, res, VTABLE_get_string(interp, val));

        if (j < n - 1)
            res = Parrot_str_append(interp, res, CONST_STRING(interp, ", "));
    }

    res = Parrot_str_append(interp, res, CONST_STRING(interp, "}"));

    return res;
#line 855 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string(PARROT_INTERP, PMC *pmc)
{
#line 613 "./src/pmc/hash.pmc"

    return Parrot_sprintf_c(interp, "Hash[0x%x]", pmc);
#line 863 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 881 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, hash,
            hash_key_from_pmc(interp, hash, key));
    PMC        *valpmc;
    PMC        *nextkey;

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    nextkey = key_next(interp, key);
    valpmc  = hash_value_to_pmc(interp, hash, b->value);

    /* Stop recursion. This is last step */
    if (!nextkey)
        return VTABLE_get_string(interp, valpmc);

    /* Recusively call to enclosed aggregate */
    return VTABLE_get_string_keyed(interp, valpmc, nextkey);
#line 888 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 860 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b =
        parrot_hash_get_bucket(interp, hash, hash_key_from_int(interp, hash, key));

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    return hash_value_to_string(interp, hash, b->value);
#line 903 "./src/pmc/hash.c"
}
static  STRING  *
Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 849 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash*)VTABLE_get_pointer(interp, pmc);
    HashBucket * const b =
        parrot_hash_get_bucket(interp, hash, hash_key_from_string(interp, hash, key));

    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    return hash_value_to_string(interp, hash, b->value);
#line 918 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_init(PARROT_INTERP, PMC *pmc)
{
#line 396 "./src/pmc/hash.pmc"

    Parrot_Hash_attributes * const attr =
        mem_allocate_typed(Parrot_Hash_attributes);

    PMC_data(pmc)        = attr;
    attr->hash            = parrot_new_hash(interp);
    attr->hash->container = pmc;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 932 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1317 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, pmc);
    INTVAL      j, n;

    if (value->vtable->base_type != pmc->vtable->base_type)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC           *item1, *item2;
        INTVAL         result;

        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;

        item1 = VTABLE_get_pmc_keyed_str(interp, pmc, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);

        if (item1 == item2)
            continue;

        Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal",
            "PP->I", item1, item2, &result);
        if (!result)
            return 0;
    }

    return 1;
#line 971 "./src/pmc/hash.c"
}
static  INTVAL 
Parrot_Hash_is_same(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 1300 "./src/pmc/hash.pmc"

    return (INTVAL)(other->vtable == pmc->vtable &&
        VTABLE_get_pointer(interp, other) == VTABLE_get_pointer(interp, pmc));
#line 980 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_mark(PARROT_INTERP, PMC *pmc)
{
#line 423 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    if (hash != NULL)
        parrot_mark_hash(interp, hash);
#line 990 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 730 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, pmc);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_int(interp, hash, value));
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = pmc_new(interp, VTABLE_type(interp, pmc));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 1020 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 756 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_put(interp, hash, hash_key_from_int(interp, hash, key),
            hash_value_from_int(interp, hash, value));
#line 1030 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 770 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_put(interp, hash, hash_key_from_string(interp, hash, key),
            hash_value_from_int(interp, hash, value));
#line 1040 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 478 "./src/pmc/hash.pmc"

    Hash * const old_hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    Hash *new_hash;

    if (type == Hash_key_type_STRING)
        new_hash = parrot_new_hash(interp);
    else if (type == Hash_key_type_int)
        /* new_int_hash set BOTH keys and values to INTVAL */
        new_hash = parrot_create_hash(interp,
                old_hash ? old_hash->entry_type : enum_type_PMC,
                Hash_key_type_int,
                int_compare,
                key_hash_int);
    else
        /*
            We probably will not implement other types of keys. They are way
            too dangerous to use from PIR
        */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Hash: Unknown key type");


    PARROT_HASH(pmc)->hash = new_hash;
    new_hash->container     = pmc;

    if (old_hash)
        parrot_hash_destroy(interp, old_hash);
#line 1073 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 1024 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, pmc);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box            = PMCNULL;
    HashBucket *b;


    if (!nextkey) {
        PMC * const val = get_number_pmc(interp);
        VTABLE_set_number_native(interp, val, value);
        parrot_hash_put(interp, hash, keystr, hash_value_from_pmc(interp, hash, val));
        return;
    }

    b = parrot_hash_get_bucket(interp, (Hash *)VTABLE_get_pointer(interp, pmc), keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);

    /* autovivify an Hash */
    if (PMC_IS_NULL(box))
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 1103 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
#line 1060 "./src/pmc/hash.pmc"

    PMC * const val  = get_number_pmc(interp);
    VTABLE_set_number_native(interp, val, value);

    parrot_hash_put(interp, (Hash *)VTABLE_get_pointer(interp, pmc), key, val);
#line 1114 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 1075 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, pmc);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr, value);
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = pmc_new(interp, VTABLE_type(interp, pmc));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }


    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 1144 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 1111 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_put(interp, hash, hash_key_from_string(interp, hash, key),
            hash_value_from_pmc(interp, hash, value));
#line 1154 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_pointer(PARROT_INTERP, PMC *pmc, void *ptr)
{
#line 458 "./src/pmc/hash.pmc"

    Hash * const old_hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    Hash * const new_hash = (Hash *)ptr;

    PARROT_HASH(pmc)->hash = new_hash;
    new_hash->container     = pmc;

    if (old_hash)
        parrot_hash_destroy(interp, old_hash);
#line 1169 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 910 "./src/pmc/hash.pmc"

    Hash   * const hash    = (Hash *)VTABLE_get_pointer(interp, pmc);
    void   * const keystr  = hash_key_from_pmc(interp, hash, key);
    PMC    * const nextkey = key_next(interp, key);
    PMC    *box;
    HashBucket *b;

    if (!nextkey) {
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_string(interp, hash, value));
        return;
    }

    b = parrot_hash_get_bucket(interp, hash, keystr);
    if (b)
        box = hash_value_to_pmc(interp, hash, b->value);
    else {
        /* autovivify an Hash */
        box = pmc_new(interp, VTABLE_type(interp, pmc));
        parrot_hash_put(interp, hash, keystr,
                hash_value_from_pmc(interp, hash, box));
    }

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 1199 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 951 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_put(interp, hash,
            hash_key_from_int(interp, hash, key),
            hash_value_from_string(interp, hash, value));
#line 1210 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 944 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)VTABLE_get_pointer(interp, pmc);
    parrot_hash_put(interp, hash,
            hash_key_from_string(interp, hash, key),
            hash_value_from_string(interp, hash, value));
#line 1221 "./src/pmc/hash.c"
}
static  PMC  *
Parrot_Hash_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1362 "./src/pmc/hash.pmc"

    if (f == 0) {
        return VTABLE_get_iter(interp, pmc);
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
        "Hash: Unknown slice type");
#line 1234 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1418 "./src/pmc/hash.pmc"

    IMAGE_IO * const io = info->image_io;

    interp->vtables[enum_class_default]->thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems  = VTABLE_shift_integer(interp, io);
        const INTVAL k_type = VTABLE_shift_integer(interp, io);
        const INTVAL v_type = VTABLE_shift_integer(interp, io);
        Hash        *hash;

        /* RT #46653 create hash with needed size in the first place */
        if (k_type == Hash_key_type_int && v_type == enum_hash_int) {
            VTABLE_set_pointer(interp, pmc, parrot_new_intval_hash(interp));
        }

        hash = (Hash *)VTABLE_get_pointer(interp, pmc);

        PARROT_ASSERT((INTVAL)hash->key_type == k_type);
        PARROT_ASSERT(hash->entry_type       == v_type);

        hash->container = pmc;
        hash->entries   = elems;
    }
#line 1263 "./src/pmc/hash.c"
}
static  void 
Parrot_Hash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1382 "./src/pmc/hash.pmc"

    info->container = pmc;
    parrot_hash_visit(interp, (Hash *)VTABLE_get_pointer(interp, pmc), info);
    interp->vtables[enum_class_default]->visit(interp, pmc, info);
#line 1273 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_set_key_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1312 "./src/pmc/hash.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1329 "./src/pmc/hash.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 507 "./src/pmc/hash.pmc"

    pmc->vtable->set_integer_native(interp, pmc, type);
#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1354 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_key_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1392 "./src/pmc/hash.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1409 "./src/pmc/hash.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 511 "./src/pmc/hash.pmc"

    const INTVAL ret = ((Hash *)pmc->vtable->get_pointer(interp, pmc))->key_type;
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
    /*BEGIN GENERATED ACCESSORS */
#line 1423 "./src/pmc/hash.pmc"
    CTX_REG_INT(_ctx, 0) = ret;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto get_key_type_returns;
    /*END RETURN INTVAL ret */
    }
#line 513 "./src/pmc/hash.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_key_type_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1468 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_set_value_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1507 "./src/pmc/hash.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1524 "./src/pmc/hash.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 527 "./src/pmc/hash.pmc"

    Hash *old_hash = (Hash *)pmc->vtable->get_pointer(interp, pmc);
    Hash *new_hash;

    /*
    If someone called Hash.set_pointer with NULL pointer...
    It will create STRING* keys hash. Because we can't use STRING_compare
    directly - it declared static in F<src/hash.c>
    */
    if (!old_hash)
        old_hash = parrot_new_hash(interp);

    switch (type) {
        case enum_type_INTVAL:
        case enum_type_STRING:
        case enum_type_PMC:
            new_hash = parrot_create_hash(interp,
                    (PARROT_DATA_TYPE)type,
                    old_hash->key_type,
                    old_hash->compare,
                    old_hash->hash_val);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
                    "Hash: unsupported entry_type");
    }

    PARROT_HASH(pmc)->hash = new_hash;
    new_hash->container     = pmc;

    parrot_hash_destroy(interp, old_hash);
#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1578 "./src/pmc/hash.c"
}
static  void
Parrot_Hash_nci_get_value_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1616 "./src/pmc/hash.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1633 "./src/pmc/hash.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 560 "./src/pmc/hash.pmc"

    INTVAL ret = ((Hash *)pmc->vtable->get_pointer(interp, pmc))->entry_type;
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL ret */
    /*BEGIN GENERATED ACCESSORS */
#line 1647 "./src/pmc/hash.pmc"
    CTX_REG_INT(_ctx, 0) = ret;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto get_value_type_returns;
    /*END RETURN INTVAL ret */
    }
#line 562 "./src/pmc/hash.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_value_type_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1692 "./src/pmc/hash.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Hash_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->delete_keyed = Parrot_Hash_delete_keyed;
    vt->delete_keyed_str = Parrot_Hash_delete_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->init = Parrot_Hash_init;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->set_integer_keyed = Parrot_Hash_set_integer_keyed;
    vt->set_integer_keyed_int = Parrot_Hash_set_integer_keyed_int;
    vt->set_integer_keyed_str = Parrot_Hash_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Hash_set_integer_native;
    vt->set_number_keyed = Parrot_Hash_set_number_keyed;
    vt->set_number_keyed_str = Parrot_Hash_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_Hash_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_Hash_set_pmc_keyed_str;
    vt->set_pointer = Parrot_Hash_set_pointer;
    vt->set_string_keyed = Parrot_Hash_set_string_keyed;
    vt->set_string_keyed_int = Parrot_Hash_set_string_keyed_int;
    vt->set_string_keyed_str = Parrot_Hash_set_string_keyed_str;
    vt->slice = Parrot_Hash_slice;
    vt->thaw = Parrot_Hash_thaw;
    vt->visit = Parrot_Hash_visit;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Hash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Hash_clone;
    vt->defined_keyed = Parrot_Hash_defined_keyed;
    vt->defined_keyed_str = Parrot_Hash_defined_keyed_str;
    vt->destroy = Parrot_Hash_destroy;
    vt->elements = Parrot_Hash_elements;
    vt->exists_keyed = Parrot_Hash_exists_keyed;
    vt->exists_keyed_str = Parrot_Hash_exists_keyed_str;
    vt->freeze = Parrot_Hash_freeze;
    vt->get_bool = Parrot_Hash_get_bool;
    vt->get_integer = Parrot_Hash_get_integer;
    vt->get_integer_keyed = Parrot_Hash_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_Hash_get_integer_keyed_int;
    vt->get_integer_keyed_str = Parrot_Hash_get_integer_keyed_str;
    vt->get_iter = Parrot_Hash_get_iter;
    vt->get_number = Parrot_Hash_get_number;
    vt->get_number_keyed = Parrot_Hash_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Hash_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Hash_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Hash_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Hash_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Hash_get_pmc_keyed_str;
    vt->get_pointer = Parrot_Hash_get_pointer;
    vt->get_repr = Parrot_Hash_get_repr;
    vt->get_string = Parrot_Hash_get_string;
    vt->get_string_keyed = Parrot_Hash_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Hash_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Hash_get_string_keyed_str;
    vt->init = Parrot_Hash_init;
    vt->is_equal = Parrot_Hash_is_equal;
    vt->is_same = Parrot_Hash_is_same;
    vt->mark = Parrot_Hash_mark;
    vt->slice = Parrot_Hash_slice;
    vt->visit = Parrot_Hash_visit;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Hash_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Hash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Hash_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Hash_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Hash", 4, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Hash_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Hash")), PMCNULL);
    return isa;
}

void
Parrot_Hash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Hash_get_vtable(interp);
        vt->base_type      = enum_class_Hash;
        vt->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Hash");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Hash_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Hash;
            vt_ro->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Hash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_set_key_type), CONST_STRING_GEN(interp, "set_key_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_get_key_type), CONST_STRING_GEN(interp, "get_key_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_set_value_type), CONST_STRING_GEN(interp, "set_value_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Hash_nci_get_value_type), CONST_STRING_GEN(interp, "get_value_type"));
        {
        }
    } /* pass */
} /* Parrot_Hash_class_init */
#line 1441 "./src/pmc/hash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
