/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/iterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "iterator.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/iterator.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: iterator.pmc 40134 2009-07-17 13:55:17Z fperrad $

=head1 NAME

src/pmc/iterator.pmc - Iterator PMC

=head1 DESCRIPTION

These are the vtable functions for the Iterator base class. Iterators are
used in combination with other classes(mainly aggregates) to visit all entries
in that aggregate.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate over a hash

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key..
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head1 Methods

=over 4

=cut

*/
#line 81 "./src/pmc/iterator.c"
static  INTVAL  Parrot_Iterator_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_Iterator_get_iter(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_Iterator_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *aggregate);
static  void  Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Iterator_nci_next(PARROT_INTERP, PMC *pmc);
void    Parrot_Iterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Iterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Iterator_get_vtable(PARROT_INTERP);
void    Parrot_Iterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Iterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Iterator_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_Iterator_defined(PARROT_INTERP, PMC *pmc)
{
#line 178 "./src/pmc/iterator.pmc"

    return (INTVAL)(VTABLE_get_pmc(interp, pmc) != PMCNULL);
#line 106 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 190 "./src/pmc/iterator.pmc"

    return VTABLE_defined_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 114 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 164 "./src/pmc/iterator.pmc"

    return VTABLE_exists_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 122 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 112 "./src/pmc/iterator.pmc"

    return VTABLE_get_integer_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 130 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 195 "./src/pmc/iterator.pmc"

    return pmc;
#line 138 "./src/pmc/iterator.c"
}
static  FLOATVAL 
Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 124 "./src/pmc/iterator.pmc"

    return VTABLE_get_number_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 146 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 150 "./src/pmc/iterator.pmc"

    return VTABLE_get_pmc_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 154 "./src/pmc/iterator.c"
}
static  STRING  *
Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 137 "./src/pmc/iterator.pmc"

    return VTABLE_get_string_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 162 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init(PARROT_INTERP, PMC *pmc)
{
#line 72 "./src/pmc/iterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Iterator init without aggregate");
#line 171 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *aggregate)
{
#line 88 "./src/pmc/iterator.pmc"

    if (VTABLE_does(interp, aggregate, CONST_STRING(interp, "array"))
        || VTABLE_does(interp, aggregate, CONST_STRING(interp, "hash"))
        || VTABLE_does(interp, aggregate, CONST_STRING(interp, "string"))) {
        /* It's ugly hack... But I cant figure out proper way to do it. */
        PMC * const real_iter = VTABLE_get_iter(interp, aggregate);
        pmc = pmc_reuse_init(interp, pmc, VTABLE_type(interp, real_iter), aggregate, 0);
        return;
    }
    else {
        /* Die horribly */
        PARROT_ASSERT(!"Unsupported Aggregate for Iterator");
    }
#line 190 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 215 "./src/pmc/iterator.pmc"

    PMC *self = pmc;
    PARROT_ASSERT(!"Iterator: implementation have to override this method");

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Iterator: unimplemented method");
#line 202 "./src/pmc/iterator.c"
}
static  void
Parrot_Iterator_nci_next(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 240 "./src/pmc/iterator.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 257 "./src/pmc/iterator.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 201 "./src/pmc/iterator.pmc"

    PMC * const next = VTABLE_shift_pmc(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC* next */
    /*BEGIN GENERATED ACCESSORS */
#line 271 "./src/pmc/iterator.pmc"
    CTX_REG_PMC(_ctx, 0) = next;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto next_returns;
    /*END RETURN PMC* next */
    }
#line 203 "./src/pmc/iterator.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
next_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 316 "./src/pmc/iterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Iterator_update_vtable(VTABLE *vt) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->init = Parrot_Iterator_init;
    vt->init_pmc = Parrot_Iterator_init_pmc;
    vt->set_integer_native = Parrot_Iterator_set_integer_native;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Iterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->init = Parrot_Iterator_init;
    vt->init_pmc = Parrot_Iterator_init_pmc;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Iterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Iterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Iterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Iterator", 8, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Iterator_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Iterator")), PMCNULL);
    return isa;
}

void
Parrot_Iterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Iterator_get_vtable(interp);
        vt->base_type      = enum_class_Iterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Iterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Iterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Iterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Iterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Iterator_nci_next), CONST_STRING_GEN(interp, "next"));
        {
        }
    } /* pass */
} /* Parrot_Iterator_class_init */
#line 221 "./src/pmc/iterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
