/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/lexinfo.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_lexinfo.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "lexinfo.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/lexinfo.pmc"
/*
Copyright (C) 2008, Parrot Foundation.
$Id: lexinfo.pmc 38794 2009-05-15 16:12:33Z coke $

=head1 NAME

src/pmc/lexinfo.pmc - LexInfo PMC

=head1 DESCRIPTION

These are the vtable functions for the lexinfo PMC.

=head2 Functions

=over 4

=cut

*/

/* included manually to prevent breaking C++ builds -- see RT #56534*/
#include "pmc_hash.h"

/*
 * LexInfo contains a constant Hash with constant string
 * keys and integer indices - no marking and no pmc_ext
 * needed (except for freeze/thaw
 */
#line 52 "./src/pmc/lexinfo.c"
static  INTVAL  Parrot_LexInfo_elements(PARROT_INTERP, PMC *pmc);
static  void  Parrot_LexInfo_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_LexInfo_init_pmc(PARROT_INTERP, PMC *pmc, PMC *sub);
static  PMC  * Parrot_LexInfo_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what);
static  void  Parrot_LexInfo_thaw(PARROT_INTERP, PMC *pmc, visit_info *info);
static  void Parrot_LexInfo_nci_declare_lex_preg(PARROT_INTERP, PMC *pmc);
void    Parrot_LexInfo_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_LexInfo_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_LexInfo_get_vtable(PARROT_INTERP);
void    Parrot_LexInfo_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_LexInfo_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_LexInfo_ro_get_vtable(PARROT_INTERP);
static  INTVAL 
Parrot_LexInfo_elements(PARROT_INTERP, PMC *pmc)
{
#line 98 "./src/pmc/lexinfo.pmc"

    return parrot_hash_size(interp, (Hash *)VTABLE_get_pointer(interp, pmc));
#line 71 "./src/pmc/lexinfo.c"
}
static  void 
Parrot_LexInfo_init(PARROT_INTERP, PMC *pmc)
{
#line 57 "./src/pmc/lexinfo.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Cannot create a LexInfo PMC without an initializer");
#line 80 "./src/pmc/lexinfo.c"
}
static  void 
Parrot_LexInfo_init_pmc(PARROT_INTERP, PMC *pmc, PMC *sub)
{
#line 62 "./src/pmc/lexinfo.pmc"

    Hash                      *hash;
    Parrot_LexInfo_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_LexInfo_attributes);
    PARROT_ASSERT(PObj_constant_TEST(pmc));

    hash = parrot_create_hash(interp,
        (PARROT_DATA_TYPE)enum_hash_int,
        Hash_key_type_STRING,
        (hash_comp_fn)Parrot_str_not_equal,     /* STRING compare */
        (hash_hash_key_fn)Parrot_str_to_hashval); /*        hash    */

    PMC_data(pmc) = attrs;
    VTABLE_set_pointer(interp, pmc, hash);
    PObj_active_destroy_SET(pmc);
#line 101 "./src/pmc/lexinfo.c"
}
static  PMC  *
Parrot_LexInfo_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 114 "./src/pmc/lexinfo.pmc"

    if (Parrot_str_equal(interp, what, CONST_STRING(interp, "symbols"))) {
        PMC *result     = pmc_new(interp, enum_class_ResizableStringArray);
        Hash *hash      = (Hash *)VTABLE_get_pointer(interp, pmc);
        UINTVAL entries = hash->entries;
        UINTVAL found   = 0;
        INTVAL  i;

        for (i = hash->mask; i >= 0; --i) {
            HashBucket *bucket = hash->bi[i];
            while (bucket) {
                if (++found > entries)
                    Parrot_ex_throw_from_c_args(interp, NULL, 1,
                        "Detected corruption at LexInfo hash %p entries %d",
                        hash, (int)entries);

                PARROT_ASSERT(bucket->key);
                VTABLE_push_string(interp, result, (STRING *)bucket->key);

                bucket = bucket->next;
            }
        }

        return result;
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
#line 135 "./src/pmc/lexinfo.c"
}
static  void 
Parrot_LexInfo_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 160 "./src/pmc/lexinfo.pmc"

    IMAGE_IO * const io = info->image_io;

    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems  = VTABLE_shift_integer(interp, io);
        const INTVAL k_type = VTABLE_shift_integer(interp, io);
        const INTVAL v_type = VTABLE_shift_integer(interp, io);
        Hash        *hash;

        UNUSED(k_type);
        UNUSED(v_type);

        PARROT_ASSERT(v_type == enum_hash_int);
        /* TODO make a better interface for hash creation
         * TODO create hash with needed types in the first place
         */

        VTABLE_init_pmc(interp, pmc, NULL);
        hash          = (Hash *)VTABLE_get_pointer(interp, pmc);
        hash->entries = elems;
    }
    else {
        interp->vtables[enum_class_Hash]->thaw(interp, pmc, info);
    }
#line 165 "./src/pmc/lexinfo.c"
}
static  void
Parrot_LexInfo_nci_declare_lex_preg(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 205 "./src/pmc/lexinfo.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 222 "./src/pmc/lexinfo.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL preg = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 94 "./src/pmc/lexinfo.pmc"

    parrot_hash_put(interp, (Hash *)pmc->vtable->get_pointer(interp, pmc), name, (void*)preg);
#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 248 "./src/pmc/lexinfo.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_LexInfo_update_vtable(VTABLE *vt) {
    vt->elements = Parrot_LexInfo_elements;
    vt->init = Parrot_LexInfo_init;
    vt->init_pmc = Parrot_LexInfo_init_pmc;
    vt->inspect_str = Parrot_LexInfo_inspect_str;
    vt->thaw = Parrot_LexInfo_thaw;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_LexInfo_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_LexInfo_elements;
    vt->init = Parrot_LexInfo_init;
    vt->init_pmc = Parrot_LexInfo_init_pmc;
    vt->inspect_str = Parrot_LexInfo_inspect_str;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_LexInfo_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_get_vtable(interp);
    Parrot_LexInfo_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_LexInfo_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Hash_ro_get_vtable(interp);
    Parrot_LexInfo_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_LexInfo_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Hash_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "LexInfo", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_LexInfo_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Hash_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "LexInfo")), PMCNULL);
    return isa;
}

void
Parrot_LexInfo_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":hash ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_LexInfo_get_vtable(interp);
        vt->base_type      = enum_class_LexInfo;
        vt->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "LexInfo");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_LexInfo_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_LexInfo_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_LexInfo;
            vt_ro->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_LexInfo_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_LexInfo_nci_declare_lex_preg), CONST_STRING_GEN(interp, "declare_lex_preg"));
        /* class_init */
        {
        
        
            /* there is no pmclass const_pmc flag yet */
            if (pass == 1)
                interp->vtables[entry]->flags |= VTABLE_IS_CONST_PMC_FLAG;
        

        }
        {
        }
    } /* pass */
} /* Parrot_LexInfo_class_init */
#line 184 "./src/pmc/lexinfo.pmc"



/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd20_lexical_vars.pod>, F<src/classes/lexpad.pmc>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
