/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/stringhandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_stringhandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "stringhandle.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/stringhandle.pmc"
/*
Copyright (C) 2008, Parrot Foundation.
$Id: stringhandle.pmc 39782 2009-06-25 22:29:08Z chromatic $

=head1 NAME

src/pmc/stringhandle.pmc - StringHandle PMC

=head1 DESCRIPTION

The StringHandle PMC performs I/O operations, but on an internal string rather
than an external file. Commonly used as a mock FileHandle for testing.

=cut

*/

#include "../src/io/io_private.h"

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(STRING *s));

/*

=head2 Internal Functions

=over 4

=item C<static int encoding_is_utf8()>

Helper function for internal usage. Return 1 if the string argument is
not null and has utf8 encoding, 0 otherwise.

=back

=cut

*/

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(STRING *s))
{
    if (STRING_IS_NULL(s))
        return 0;
    else
        return Parrot_str_equal(interp, s, CONST_STRING(interp, "utf8"));
}
#line 71 "./src/pmc/stringhandle.c"
static  PMC  * Parrot_StringHandle_clone(PARROT_INTERP, PMC *pmc);
static  void  Parrot_StringHandle_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_StringHandle_get_bool(PARROT_INTERP, PMC *pmc);
static  void  Parrot_StringHandle_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_StringHandle_mark(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_open(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_is_tty(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_close(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_is_closed(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_read(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_readline(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_readall(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_flush(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_print(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_puts(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_mode(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_encoding(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_eof(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_get_fd(PARROT_INTERP, PMC *pmc);
void    Parrot_StringHandle_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP);
void    Parrot_StringHandle_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_StringHandle_clone(PARROT_INTERP, PMC *pmc)
{
#line 97 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const old_struct  = PARROT_STRINGHANDLE(pmc);
    PMC * const copy = pmc_new(interp, enum_class_StringHandle);
    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(copy);

    if (old_struct->stringhandle != NULL)
        data_struct->stringhandle = Parrot_str_copy(interp, old_struct->stringhandle);
    if (old_struct->mode != NULL)
        data_struct->mode     = Parrot_str_copy(interp, old_struct->mode);
    if (old_struct->encoding != NULL)
        data_struct->encoding = Parrot_str_copy(interp, old_struct->encoding);
    data_struct->flags    = old_struct->flags;

    return copy;
#line 117 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_destroy(PARROT_INTERP, PMC *pmc)
{
#line 144 "./src/pmc/stringhandle.pmc"

    if (PARROT_STRINGHANDLE(pmc)) {
        mem_sys_free(PARROT_STRINGHANDLE(pmc));
        PMC_data(pmc) = NULL;
    }
#line 128 "./src/pmc/stringhandle.c"
}
static  INTVAL 
Parrot_StringHandle_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 161 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        return 0;

    return 1;
#line 142 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_init(PARROT_INTERP, PMC *pmc)
{
#line 71 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes *data_struct =
            mem_allocate_typed(Parrot_StringHandle_attributes);

    PMC_data(pmc)            = data_struct;
    data_struct->flags        = 0;
    data_struct->stringhandle = NULL;
    data_struct->mode         = NULL;
    data_struct->encoding     = NULL;
    data_struct->filename     = NULL;
    data_struct->read_offset  = 0;

    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);
#line 162 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_mark(PARROT_INTERP, PMC *pmc)
{
#line 123 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(pmc);
    if (data_struct->stringhandle)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)data_struct->stringhandle);
    if (data_struct->mode)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)data_struct->mode);
    if (data_struct->encoding)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)data_struct->encoding);
    if (data_struct->filename)
        Parrot_gc_mark_PObj_alive(interp, (PObj *)data_struct->filename);
#line 178 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_open(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 2, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0, 1, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 5);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 4, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 220 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 237 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* filename = CTX_REG_STR(_ctx, 0);
    INTVAL got_filename = CTX_REG_INT(_ctx, 0);
    STRING* mode = CTX_REG_STR(_ctx, 1);
    INTVAL got_mode = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 190 "./src/pmc/stringhandle.pmc"

    STRING *open_mode, *old_string;
    INTVAL flags;

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_StringHandle_mode(interp, pmc, Parrot_str_copy(interp, mode));

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_StringHandle_filename(interp, pmc, Parrot_str_copy(interp, filename));


    /* If StringHandle hasn't already been initialized, create a new string. */
    GETATTR_StringHandle_stringhandle(interp, pmc, old_string);
    if (STRING_IS_NULL(old_string)) {
        STRING *new_string;
        STRING *encoding;

        GETATTR_StringHandle_encoding(interp, pmc, encoding);
        if (encoding_is_utf8(interp, encoding))
            new_string = string_make(interp, "", 0, "unicode", 0);
        else
            new_string = Parrot_str_new(interp, "", 0);

        SETATTR_StringHandle_stringhandle(interp, pmc, new_string);
    }

    /* Set a default mode of read-only. */
    GETATTR_StringHandle_mode(interp, pmc, open_mode);
    if (STRING_IS_NULL(open_mode)) {
        open_mode = Parrot_str_new_constant(interp, "r");
        SETATTR_StringHandle_mode(interp, pmc, open_mode);
    }

    pmc = Parrot_io_open(interp, pmc, filename, open_mode);

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *pmc */
    /*BEGIN GENERATED ACCESSORS */
#line 288 "./src/pmc/stringhandle.pmc"
    CTX_REG_PMC(_ctx, 0) = pmc;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto open_returns;
    /*END RETURN PMC *pmc */
    }
#line 225 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
open_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 333 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_is_tty(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 371 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 388 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 237 "./src/pmc/stringhandle.pmc"

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 401 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto is_tty_returns;
    /*END RETURN INTVAL 0 */
    }
#line 238 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
is_tty_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 446 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_close(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 484 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 501 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 252 "./src/pmc/stringhandle.pmc"

    SETATTR_StringHandle_read_offset(interp, pmc, 0);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 515 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto close_returns;
    /*END RETURN INTVAL 0 */
    }
#line 254 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
close_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 560 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_is_closed(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 598 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 615 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 267 "./src/pmc/stringhandle.pmc"

    INTVAL status;
    status = Parrot_io_is_closed(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
    /*BEGIN GENERATED ACCESSORS */
#line 630 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = status;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto is_closed_returns;
    /*END RETURN INTVAL status */
    }
#line 270 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
is_closed_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 675 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_read(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 714 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 731 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL length = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 284 "./src/pmc/stringhandle.pmc"

    STRING *string_result;
    string_result = Parrot_io_reads(interp, pmc, length);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 747 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto read_returns;
    /*END RETURN STRING *string_result */
    }
#line 287 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
read_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 792 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_readline(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 830 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 847 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 301 "./src/pmc/stringhandle.pmc"

    STRING *string_result;
    string_result = Parrot_io_readline(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 862 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readline_returns;
    /*END RETURN STRING *string_result */
    }
#line 304 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
readline_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 907 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_readall(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 947 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 964 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL got_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 318 "./src/pmc/stringhandle.pmc"

    STRING *string_result;

    GETATTR_StringHandle_stringhandle(interp, pmc, string_result);
    if (STRING_IS_NULL(string_result)) {
        STRING *encoding;
        GETATTR_StringHandle_encoding(interp, pmc, encoding);
        if (encoding_is_utf8(interp, encoding))
            string_result = string_make(interp, "", 0, "unicode", 0);
        else
            string_result = Parrot_str_new_constant(interp, "");
    }
    else
        string_result = Parrot_str_copy(interp, string_result);

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 993 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readall_returns;
    /*END RETURN STRING *string_result */
    }
#line 333 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
readall_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1038 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_flush(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1076 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1093 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 346 "./src/pmc/stringhandle.pmc"

    Parrot_io_flush(interp, pmc);
#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1117 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_print(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1156 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1173 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* to_print = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 361 "./src/pmc/stringhandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    Parrot_io_putps(interp, pmc, string_to_print);
#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1200 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_puts(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1239 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1256 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* to_print = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 377 "./src/pmc/stringhandle.pmc"

    INTVAL flags, status;
    STRING *old_string, *new_string;

    GETATTR_StringHandle_stringhandle(interp, pmc, old_string);
    if (STRING_IS_NULL(old_string))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a closed filehandle");

    GETATTR_StringHandle_flags(interp, pmc, flags);
    if (!(flags & PIO_F_WRITE))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a filehandle not opened for write");

    new_string = Parrot_str_append(interp, old_string, to_print);

    SETATTR_StringHandle_stringhandle(interp, pmc, new_string);

    status = Parrot_str_byte_length(interp, new_string);
    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
    /*BEGIN GENERATED ACCESSORS */
#line 1288 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = status;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto puts_returns;
    /*END RETURN INTVAL status */
    }
#line 396 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
puts_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1333 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1373 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1390 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* new_type = CTX_REG_STR(_ctx, 0);
    INTVAL got_type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 410 "./src/pmc/stringhandle.pmc"

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    GETATTR_StringHandle_flags(interp, pmc, flags);

    if (got_type) {
        if (Parrot_str_equal(interp, new_type, nobuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (Parrot_str_equal(interp, new_type, linebuffer_string)) {
            flags |=   PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (Parrot_str_equal(interp, new_type, fullbuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags |=   PIO_F_BLKBUF;
        }

        SETATTR_StringHandle_flags(interp, pmc, flags);
    }

    if (flags & PIO_F_LINEBUF)
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *linebuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1430 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = linebuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *linebuffer_string */
    }
#line 436 "./src/pmc/stringhandle.pmc"

    else if (flags & PIO_F_BLKBUF)
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1454 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = fullbuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *fullbuffer_string */
    }
#line 438 "./src/pmc/stringhandle.pmc"

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *nobuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1477 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = nobuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *nobuffer_string */
    }
#line 439 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
buffer_type_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1522 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 128);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1562 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1579 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL new_size = CTX_REG_INT(_ctx, 0);
    INTVAL got_size = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 452 "./src/pmc/stringhandle.pmc"

    INTVAL buffer_size;
    STRING *stringhandle;

    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 1600 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto buffer_size_returns;
    /*END RETURN INTVAL 0 */
    }
#line 459 "./src/pmc/stringhandle.pmc"

    buffer_size = Parrot_str_byte_length(interp, stringhandle);

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL buffer_size */
    /*BEGIN GENERATED ACCESSORS */
#line 1625 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = buffer_size;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto buffer_size_returns;
    /*END RETURN INTVAL buffer_size */
    }
#line 462 "./src/pmc/stringhandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
buffer_size_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1671 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_mode(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1709 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1726 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 476 "./src/pmc/stringhandle.pmc"

    STRING *mode, *mode_copy;

    GETATTR_StringHandle_mode(interp, pmc, mode);
    mode_copy = Parrot_str_copy(interp, mode);

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *mode_copy */
    /*BEGIN GENERATED ACCESSORS */
#line 1744 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = mode_copy;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto mode_returns;
    /*END RETURN STRING *mode_copy */
    }
#line 482 "./src/pmc/stringhandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
mode_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1790 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_encoding(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1830 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1847 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* new_encoding = CTX_REG_STR(_ctx, 0);
    INTVAL got_encoding = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 497 "./src/pmc/stringhandle.pmc"

    STRING *encoding;
    STRING *encoding_copy = NULL;

    if (got_encoding) {
        if (!STRING_IS_NULL(new_encoding))
            encoding_copy = Parrot_str_copy(interp, new_encoding);
        SETATTR_StringHandle_encoding(interp, pmc, encoding_copy);
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *new_encoding */
    /*BEGIN GENERATED ACCESSORS */
#line 1869 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = new_encoding;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto encoding_returns;
    /*END RETURN STRING *new_encoding */
    }
#line 505 "./src/pmc/stringhandle.pmc"

    }

    GETATTR_StringHandle_encoding(interp, pmc, encoding);
    if (!STRING_IS_NULL(encoding))
        encoding_copy = Parrot_str_copy(interp, encoding);

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *encoding_copy */
    /*BEGIN GENERATED ACCESSORS */
#line 1898 "./src/pmc/stringhandle.pmc"
    CTX_REG_STR(_ctx, 0) = encoding_copy;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto encoding_returns;
    /*END RETURN STRING *encoding_copy */
    }
#line 512 "./src/pmc/stringhandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
encoding_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1944 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_eof(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1982 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1999 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 527 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    UINTVAL offset;
    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);
    GETATTR_StringHandle_read_offset(interp, pmc, offset);

    if (offset >= Parrot_str_byte_length(interp, stringhandle))
        #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
    /*BEGIN GENERATED ACCESSORS */
#line 2018 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = 1;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto eof_returns;
    /*END RETURN INTVAL 1 */
    }
#line 534 "./src/pmc/stringhandle.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 2042 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto eof_returns;
    /*END RETURN INTVAL 0 */
    }
#line 536 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
eof_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2087 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_get_fd(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2125 "./src/pmc/stringhandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2142 "./src/pmc/stringhandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 551 "./src/pmc/stringhandle.pmc"

    #line 237 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
    /*BEGIN GENERATED ACCESSORS */
#line 2155 "./src/pmc/stringhandle.pmc"
    CTX_REG_INT(_ctx, 0) = -1;

#line 256 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto get_fd_returns;
    /*END RETURN INTVAL -1 */
    }
#line 552 "./src/pmc/stringhandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_fd_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.4.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2200 "./src/pmc/stringhandle.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StringHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_StringHandle_clone;
    vt->destroy = Parrot_StringHandle_destroy;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_StringHandle_clone;
    vt->destroy = Parrot_StringHandle_destroy;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_StringHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_StringHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StringHandle_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "StringHandle", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StringHandle_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Handle_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StringHandle")), PMCNULL);
    return isa;
}

void
Parrot_StringHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Iflags Sstringhandle Smode Sencoding Sfilename Iread_offset ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StringHandle_get_vtable(interp);
        vt->base_type      = enum_class_StringHandle;
        vt->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StringHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StringHandle_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_StringHandle_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_StringHandle;
            vt_ro->flags          = 0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG;
            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StringHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_open), CONST_STRING_GEN(interp, "open"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_is_tty), CONST_STRING_GEN(interp, "is_tty"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_close), CONST_STRING_GEN(interp, "close"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_is_closed), CONST_STRING_GEN(interp, "is_closed"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_read), CONST_STRING_GEN(interp, "read"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_readline), CONST_STRING_GEN(interp, "readline"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_readall), CONST_STRING_GEN(interp, "readall"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_flush), CONST_STRING_GEN(interp, "flush"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_print), CONST_STRING_GEN(interp, "print"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_puts), CONST_STRING_GEN(interp, "puts"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_buffer_type), CONST_STRING_GEN(interp, "buffer_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_buffer_size), CONST_STRING_GEN(interp, "buffer_size"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_mode), CONST_STRING_GEN(interp, "mode"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_encoding), CONST_STRING_GEN(interp, "encoding"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_eof), CONST_STRING_GEN(interp, "eof"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_get_fd), CONST_STRING_GEN(interp, "get_fd"));
        {
        }
    } /* pass */
} /* Parrot_StringHandle_class_init */
#line 563 "./src/pmc/stringhandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
